function varargout = G_data(varargin)
% G_DATA MATLAB code for G_data.fig
%      G_DATA, by itself, creates a new G_DATA or raises the existing
%      singleton*.
%
%      H = G_DATA returns the handle to a new G_DATA or the handle to
%      the existing singleton*.
%
%      G_DATA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in G_DATA.M with the given input arguments.
%
%      G_DATA('Property','Value',...) creates a new G_DATA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before G_data_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to G_data_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help G_data

% Last Modified by GUIDE v2.5 25-Apr-2016 20:04:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @G_data_OpeningFcn, ...
                   'gui_OutputFcn',  @G_data_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before G_data is made visible.
function G_data_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to G_data (see VARARGIN)

% Choose default command line output for G_data
handles.output = hObject;

load (['.\sitelist.mat']);
% set species information
if ~isempty(sitelist)
    p=sitelist(:,1);
    set(handles.g_site,'string',p);
    p=cell2mat(p(1));
    f_show(handles,p);
else
    set(handles.g_site,'string',' ');
end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes G_data wait for user response (see UIRESUME)
% uiwait(handles.figure1);

function f_show(H,name)
load(['.\sitedata\' name '_date.mat']);
m=length(Date);
load(['.\sitedata\' name '_spec.mat']);
n=length(Spec);
load(['.\sitedata\' name '_unit.mat']);
cname={};
for i=1:n
    cname(i)={[cell2mat(Spec(i)) ' (' cell2mat(Unit(i)) ')']};
end
data=zeros(m,n+1);
data(:,:)=nan;
data(:,1)=Date(:,1);
rname=datenum(num2str(Date),'yyyymmddhh');
rname=datestr(rname);
rname=datestr(rname,'yyyy/mm/dd HH:MM');
for i=1:n
    load(['.\sitedata\' name '_' cell2mat(Spec(i)) '.mat']);
    [a,b]=intersect(Date(:,1),Data(:,1));
    data(b,i+1)=Data(:,2);
end
set(H.g_table,'Data',data(:,2:end),'ColumnName',cname,'RowName',rname);

% --- Outputs from this function are returned to the command line.
function varargout = G_data_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function g_site_Callback(hObject, eventdata, handles)
s=get(handles.g_site,'string');
temp=get(handles.g_site,'value');
s=cell2mat(s(temp));
f_show(handles,s);


function g_site_CreateFcn(hObject, eventdata, handles)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function pushbutton1_Callback(hObject, eventdata, handles)
load('.\pathsaved.mat');
name=get(handles.g_site,'string');
temp=get(handles.g_site,'value');
name=name(temp);
filename=[cell2mat(pathsaved(3)) '\' cell2mat(name) '.xlsx'];
a=get(handles.g_table,'columnname');
a=a';
b=get(handles.g_table,'rowname');
n=size(b);
B=cell(n(1),1);
for i=1:n(1)
    B(i)={b(i,1:end)};
end
c=get(handles.g_table,'data');

xlswrite(filename,{'Pollutants'},1,'A1');
xlswrite(filename,B,1,'A2');
xlswrite(filename,a,1,'B1');
xlswrite(filename,c,1,'B2');
msgbox('Export Finished');
