function varargout = G_export(varargin)
% G_EXPORT MATLAB code for G_export.fig
%      G_EXPORT, by itself, creates a new G_EXPORT or raises the existing
%      singleton*.
%
%      H = G_EXPORT returns the handle to a new G_EXPORT or the handle to
%      the existing singleton*.
%
%      G_EXPORT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in G_EXPORT.M with the given input arguments.
%
%      G_EXPORT('Property','Value',...) creates a new G_EXPORT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before G_export_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to G_export_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help G_export

% Last Modified by GUIDE v2.5 06-Apr-2016 14:09:14

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @G_export_OpeningFcn, ...
                   'gui_OutputFcn',  @G_export_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT


% --- Executes just before G_export is made visible.
function G_export_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to G_export (see VARARGIN)

% Choose default command line output for G_export
handles.output = hObject;

AD=getappdata(0,'AD');
h=get(AD.g_figuredis,'string');
m=get(AD.g_mapdisplay,'string');
n=AD.mapnumber;

if ~isempty(m)
    m=m(n+1:end);
    t=size(m);
    for i=1:t(1)
        temp=cell2mat(m(i));
        temp=temp(5:end);
        m(i)={temp};
    end
end
set(handles.g_list,'string',[h;m]);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes G_export wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = G_export_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function g_list_Callback(hObject, eventdata, handles)


function g_list_CreateFcn(hObject, eventdata, handles)

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function g_export_Callback(hObject, eventdata, handles)
AD=getappdata(0,'AD');
n=AD.mapnumber;

w=waitbar(0,'Exporting...');
temp=get(handles.g_list,'value');
t=length(temp);
steps=t+3;
 
load('.\pathsaved');
p=cell2mat(pathsaved(3));
 
waitbar(1/ steps);
 
o=length(AD.figures);
oo=length(AD.mapdis);
for i=1:o
    v(i)={get(AD.figures(i),'visible')};
    set(AD.figures(i),'visible','off');
    q=get(AD.figures(i),'children');
    if length(q)>1
        q=q(1);
    end
    vv(i)={get(q,'visible')};
    set(q,'visible','off');
end
waitbar(2/ steps);
 
for i=n+1:oo
    v2(i)={get(AD.mapdis(i),'visible')};
    set(AD.mapdis(i),'visible','off');
    set(AD.mapsite{1,i},'visible','off');
    set(AD.mapsitname{1,i},'visible','off');
end
waitbar(3/ steps);
 
for i=1:t
    f=temp(i);
    if f<=o
        name=get(handles.g_list,'string');
        name=cell2mat(name(f));
        if isempty(strfind(name,'Wind Rose (km/h)')) && isempty(strfind(name,'CPF'))
            hfig=figure('visible','off');
            set(AD.figures(f),'visible','on');
            q=get(AD.figures(f),'children');
            set(q,'visible','on');
            copyobj(AD.figures(f),hfig);
            print([p '\' name '.png'],hfig,'-dpng');
            delete(hfig);
            set(AD.figures(f),'visible','off');
            set(q,'visible','off');
        elseif ~isempty(strfind(name,'CPF'))
            hfig=figure('visible','off');
            q=get(AD.figures(f),'children');
            set(q,'visible','on');
            copyobj(AD.figures(f),hfig);
            g=get(hfig,'children');
            g=get(g,'children');
            legend([g(2) g(1)],'CPF','Wind Frequence','position',[350 30 0 0]);
            title(name);
            print([p '\' name '.png'],hfig,'-dpng');
            delete(hfig);
            set(q,'visible','off');
        else
            hfig=figure('visible','off');
            q=get(AD.figures(f),'children');
            set(q,'visible','on');
            copyobj(AD.figures(f),hfig);
            title(name);
            name=name(1:end-7);
            print([p '\' name '.png'],hfig,'-dpng');
            delete(hfig);
            set(q,'visible','off');
        end
    else
        hfig=figure('visible','off');
        set(AD.mapdis(f-o+n),'visible','on');
        set(AD.mapsite{1,f-o+n},'visible','on');
        set(AD.mapsitname{1,f-o+n},'visible','on');
        copyobj(AD.g_map,hfig);
        R=[1.0000    1.0000    1.0000
            1.0000    1.0000    0.8000
            1.0000    1.0000    0.6000
            1.0000    1.0000    0.4000
            1.0000    1.0000    0.2000
            1.0000    1.0000         0
            1.0000    0.8000         0
            1.0000    0.6000         0
            1.0000    0.4000         0
            1.0000    0.2000         0
            1.0000         0         0];
        colormap(R);
        co=colorbar;
        po=get(co,'position');
        po(4)=po(4)/2;
        set(co,'position',po);
        name=get(handles.g_list,'string');
        name=cell2mat(name(f));
        grid=cell2mat(AD.mapgrid(f-o+n));
        grid(find(grid==-inf))=-999;
        grid(find(grid==inf))=-999;
        grid(isnan(grid))=-999;
        xlswrite([p '\' name ' - grid.xlsx'],grid);
        print([p '\' name '.png'],hfig,'-dpng');
        delete(hfig);
        set(AD.mapdis(f-o+n),'visible','off');
        set(AD.mapsite{1,f-o+n},'visible','off');
        set(AD.mapsitname{1,f-o+n},'visible','off');
    end
    waitbar((i+3)/ steps);
end
 
for i=1:o
    set(AD.figures(i),'visible',cell2mat(v(i)));
    q=get(AD.figures(i),'children');
    set(q,'visible',cell2mat(vv(i)));
end
for i=n+1:oo
    set(AD.mapdis(i),'visible',cell2mat(v2(i)));
    set(AD.mapsite{1,i},'visible',cell2mat(v2(i)));
    set(AD.mapsitname{1,i},'visible',cell2mat(v2(i)));
end
close(w);

function g_finish_Callback(hObject, eventdata, handles)
close(handles.figure1);
