function varargout = G_import(varargin)
% G_IMPORT MATLAB code for G_import.fig
%      G_IMPORT, by itself, creates a new G_IMPORT or raises the existing
%      singleton*.
%
%      H = G_IMPORT returns the handle to a new G_IMPORT or the handle to
%      the existing singleton*.
%
%      G_IMPORT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in G_IMPORT.M with the given input arguments.
%
%      G_IMPORT('Property','Value',...) creates a new G_IMPORT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before G_import_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to G_import_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help G_import

% Last Modified by GUIDE v2.5 16-Mar-2016 22:23:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @G_import_OpeningFcn, ...
                   'gui_OutputFcn',  @G_import_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before G_import is made visible.
function G_import_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to G_import (see VARARGIN)

% Choose default command line output for G_import
handles.output = hObject;
% show site information
load(['.\sitelist.mat']);
n_temp=size(sitelist);
s_temp={};
for i=1:n_temp(1)
    temp=cell2mat(sitelist(i,1));
    load(['.\sitedata\' temp '_spec.mat']);
    load(['.\sitedata\' temp '_unit.mat']);
    lat=cell2mat(sitelist(i,2));
    long=lat(2);
    lat=lat(1);
    temp=[temp ': ' num2str(lat) ', ' num2str(long) '; '];
    n_temp2=size(Spec);
    for j=1:n_temp2(1)
        load(['.\sitedata\' cell2mat(sitelist(i,1)) '_' cell2mat(Spec(j)) '.mat']);
        n=size(Data);
        temp=[temp cell2mat(Spec(j)) '_' cell2mat(Unit(j)) '_' num2str(n(1)) '; '];
    end
    s_temp(i)={temp};
end
set(handles.g_site,'string',s_temp);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes G_import wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = G_import_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function g_close_Callback(hObject, eventdata, handles)
close(handles.figure1);

%------------------------------------------------------------------------------

% show lati and long if the site is already exist
function g_name_Callback(hObject, eventdata, handles)
temp=get(handles.g_name,'string');
load('.\sitelist.mat');
n=size(sitelist);
for i=1:n(1)
    if strcmp(temp,cell2mat(sitelist(i,1)))
        temp=cell2mat(sitelist(i,2));
        set(handles.g_location,'string',[num2str(temp(1)), ', ' num2str(temp(2))]);
        return;
    end
end

% make sure the date format in import data is identifiable 
function g_convert_Callback(hObject, eventdata, handles)
% test the date formation
temp=get(handles.g_date,'string');
temp=datevec(temp);
s_temp=[num2str(temp(1)) '/' num2str(temp(2))...
    '/' num2str(temp(3)) ' ' ];
if temp(4)<10
    s_temp=[s_temp '0' num2str(temp(4))];
else
    s_temp=[s_temp num2str(temp(4))];
end
if temp(5)<10
    s_temp=[s_temp ':0' num2str(temp(5))];
else
    s_temp=[s_temp ':' num2str(temp(5))];
end
set(handles.g_date2,'string',s_temp);

% get import data path and show it
function g_path_Callback(hObject, eventdata, handles)
[filename,filepath]=uigetfile('*.xls;*.xlsx;*.csv','Please select a file');
temp=[filepath filename];
set(handles.g_data,'string',temp);


% right click to show detail site information
function g_site_ButtonDownFcn(hObject, eventdata, handles)
h_main=figure('name','Site Information','menubar','none','numbertitle','off','papersize',[20 30]);
temp=get(handles.g_site,'string');
uicontrol('style','edit','parent',h_main,'position',[30 20 500 380],'string',temp,'max',1000,'horizontalalignment','left');

function g_import_Callback(hObject, eventdata, handles)
% get information
temp1=get(handles.g_name,'string'); % site name
% !!
if iscell(temp1)
    temp1=cell2mat(temp1);
end
temp2=get(handles.g_location,'string');
index=find(temp2==',');
lati=str2num(temp2(1:index));
longi=str2num(temp2(index+1:end));
temp3=str2num(get(handles.g_missing,'string')); % missing data
temp4=get(handles.g_data,'string'); % file path
% check information
check=1;
if isempty(temp1)
    check=0;
end
if isempty(lati) || isempty(longi)
    check=0;
end
if isempty(temp3)
    check=0;
end
if  exist(temp4,'file')==0
    check=0;
end

if check==0
    msgbox('Please check your input data.','Error','error');
    return;
end
% update sitelist.mat (sitelist, cell n*2)
load (['.\sitelist.mat']);
n_temp=size(sitelist);
check=1;
for i=1:n_temp(1)
    if strcmp(cell2mat(sitelist(i,1)),temp1)
        check=0;
    end
end
if check==1
n_temp(1)=n_temp(1)+1;
sitelist(n_temp(1),1)={temp1};
sitelist(n_temp(1),2)={[lati longi]};
end
% import data
[num,txt,raw] = xlsread(temp4);
% missing data >> nan
index=find(num==temp3);
num(index)=nan;

% add or update site information
% sitename_date.mat (Date, n*1) 2014010100, yyyymmddHH
% sitename_spec.mat (Spec, cell 1*n)
% sitename_speciesname (Data, n*2, date; conc.)

% current input date and species
spec=raw(1,2:end);
spec=spec';
unit=raw(2,2:end);
unit=unit';
n_temp=size(spec);
% existed date and spec
if exist(['.\sitedata\' temp1 '_date.mat'])~=0
    load(['.\sitedata\' temp1 '_date.mat']);
else
    Date=[];
end
if exist(['.\sitedata\' temp1 '_spec.mat'])~=0
    load(['.\sitedata\' temp1 '_spec.mat']);
else
    Spec={};
end
if exist(['.\sitedata\' temp1 '_unit.mat'])~=0
    load(['.\sitedata\' temp1 '_unit.mat']);
else
    Unit={};
end
if exist(['.\sitedata\' temp1 '_trajectory.mat'])~=0
    load(['.\sitedata\' temp1 '_trajectory.mat']);
else
    Trajectory={};
end
% updata date and spec
% Date: 1 date, 2 edas trajectory time, 3 narr time, 4gbl time
[Spec, a, b]=union(Spec,spec);
Unit=[Unit(a) unit(b)];
save(['.\sitedata\' temp1 '_spec.mat'],'Spec');
save(['.\sitedata\' temp1 '_unit.mat'],'Unit');
save(['.\sitedata\' temp1 '_trajectory.mat'],'Trajectory');
date=datevec(txt(3:end,1));
date=date(:,4)+date(:,3)*100+date(:,2)*10000+date(:,1)*1000000;
Date=[Date; date];
[a,b]=unique(Date(:,1),'first');% keep trajectory information
Date=Date(b,:);
Date=sortrows(Date,1);
save(['.\sitedata\' temp1 '_date.mat'],'Date');
% updata data
for i=1:n_temp(1)
    if exist(['.\sitedata\' temp1 '_' cell2mat(spec(i)) '.mat'])~=0
        load(['.\sitedata\' temp1 '_' cell2mat(spec(i)) '.mat']);
    else
        Data=[];
    end
    data=[date(:,1) num(:,i)];
    Data=[Data;data];
    [a,b]=unique(Data(:,1),'last');% updata conc. information
    Data=Data(b,:);
    Data=sortrows(Data,1);
    index=find(~isnan(Data(:,2)));
    Data=Data(index,:);
    save(['.\sitedata\' temp1 '_' cell2mat(spec(i)) '.mat'],'Data');
end

save(['.\sitelist.mat'],'sitelist');

% show site information
n_temp=size(sitelist);
s_temp={};
for i=1:n_temp(1)
    temp=cell2mat(sitelist(i,1));
    load(['.\sitedata\' temp '_spec.mat']);
    load(['.\sitedata\' temp '_unit.mat']);
    lat=cell2mat(sitelist(i,2));
    long=lat(2);
    lat=lat(1);
    temp=[temp ': ' num2str(lat) ', ' num2str(long) '; ' ];
    n_temp2=size(Spec);
    for j=1:n_temp2(1)
        load(['.\sitedata\' cell2mat(sitelist(i,1)) '_' cell2mat(Spec(j)) '.mat']);
        n=size(Data);
        temp=[temp cell2mat(Spec(j)) '_' cell2mat(Unit(j)) '_' num2str(n(1)) '; '];
    end
    s_temp(i)={temp};
end
set(handles.g_site,'string',s_temp);
