function varargout = G_main(varargin)
% G_MAIN MATLAB code for G_main.fig
%      G_MAIN, by itself, creates a new G_MAIN or raises the existing
%      singleton*.
%
%      H = G_MAIN returns the handle to a new G_MAIN or the handle to
%      the existing singleton*.
%
%      G_MAIN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in G_MAIN.M with the given input arguments.
%
%      G_MAIN('Property','Value',...) creates a new G_MAIN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before G_main_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to G_main_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help G_main

% Last Modified by GUIDE v2.5 20-Jun-2016 16:37:50

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @G_main_OpeningFcn, ...
    'gui_OutputFcn',  @G_main_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before G_main is made visible.
function G_main_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to G_main (see VARARGIN)

% Choose default command line output for G_main
handles.output = hObject;
setappdata(0, 'AD', handles);
% creat basic files when first open
if ~exist(['.\sitelist.mat'],'file')
    sitelist={};
    save(['.\sitelist.mat'],'sitelist');
end
if ~exist(['.\parameter.mat'],'file')
    peaknumber=10;
    Grid=0.5;
    mapprojection='robinson';
    CPF=0.8;
    PSCF=0.8;
    CPFdiscard=5;
    save(['.\parameter.mat'],'peaknumber','Grid','mapprojection','CPF','PSCF','CPFdiscard');
end
if ~exist(['.\lasttraj.mat'],'file')
    lasttraj={};
    save(['.\lasttraj.mat'],'lasttraj');
end
if ~exist(['.\addeditem.mat'],'file')
    addeditem={};
    save(['.\addeditem.mat'],'addeditem');
else
    load('.\addeditem.mat');
    if ~isempty(addeditem)
        s=addeditem(:,1);
        set(handles.g_addeditem,'string',s);
        s=size(addeditem);
        set(handles.g_addeditem,'value',s(1));
    end
end

if ~exist(['.\pathsaved.mat'],'file')
    pathsaved={};
    save(['.\pathsaved.mat'],'pathsaved');
end

if ~exist(['.\working'],'dir')
    mkdir(['.\working']);
    mkdir(['.\bdyfiles']);
    movefile('CONTROL','.\working');
    movefile('hyts_std.exe','.\working');
    movefile('SETUP.CFG','.\working');
    movefile('TRAJ.CFG','.\working');
    movefile('ASCDATA.CFG','.\bdyfiles');
    movefile('LANDUSE.ASC','.\bdyfiles');
    movefile('prntbdy.f','.\bdyfiles');
    movefile('ROUGLEN.ASC','.\bdyfiles');
    movefile('TERRAIN.ASC','.\bdyfiles');
    movefile('README','.\bdyfiles');
end

if ~exist(['.\sitedata'],'dir')
    mkdir(['.\sitedata']);
end

if ~exist(['.\trajdata'],'dir')
    mkdir(['.\trajdata']);
end

% set up default
load('.\addeditem.mat');
if ~isempty(addeditem)
    set(handles.g_addeditem,'string',addeditem(:,1));
end

handles.zoom=0;
handles.pan=0;
handles.rotate3=0;
handles.Focus=0;
handles.Peak=0;

handles.tif=[];
handles.figures=[];
handles.figuredata={};
handles.legend=[];
handles.mapnumber=0;
handles.mapdis={};
handles.mapgrid={};
handles.gridfocus={};
handles.gridpeak={};
handles.gridpeak2={};
handles.selectedevent={};
% Update handles structure
guidata(hObject, handles);



% UIWAIT makes G_main wait for user response (see UIRESUME)
% uiwait(handles.g_GTBPSA);


% --- Outputs from this function are returned to the command line.
function varargout = G_main_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%-------------------------------

% menu functions

%-------------------------------
function g_import_Callback(hObject, eventdata, handles)
G_import;

function g_delete_Callback(hObject, eventdata, handles)
G_delete;

function g_pathset_Callback(hObject, eventdata, handles)
G_setpath;

function g_close_Callback(hObject, eventdata, handles)
close(handles.g_GTBPSA);

function g_settraj_Callback(hObject, eventdata, handles)
load ('.\pathsaved.mat');
if isempty(pathsaved)
    uiwait(msgbox('Please setup path first.','Error','error'));
    uiwait(G_setpath);
    return;
end
G_settraj;

function g_runtraj_Callback(hObject, eventdata, handles)
load ('.\pathsaved.mat');
if isempty(pathsaved)
    msgbox('Please setup path first.','Error','error');
    return;
end
% load information
load('.\pathsaved');
load('.\parameter','op1','op2','head','trajnumber','trajsite','trajtime','trajmetero','trajdate','trajheight');
% run bat file
h = waitbar(0,'','name','Running HYSPLIT...');

if cell2mat(pathsaved(5))==1
    winopen([cell2mat(pathsaved(4)) '.\working\G.vbs']);
else
    winopen(['.\working\G.vbs']);
end

steps = trajnumber;
count=0;
while count~=steps
    pause(1);
    % computations take place here
    if exist([cell2mat(pathsaved(3)) '\count.txt'])
        count=textread([cell2mat(pathsaved(3)) '\count.txt' ]);
    end
    if isnumeric(count(1))
        waitbar(count(1)/ steps,h,[num2str(count(1)) '/' num2str(steps)]);
    end
end
close(h);

if op2==1
    % initialize
    lati=zeros(trajnumber,abs(trajtime)+2); % date, endpoints (0~time)
    lati(:,:)=nan;
    longi=lati;
    alti=lati;
    
    hh = waitbar(0,'','name','Importing Endpoints...');
    steps=trajnumber;
    shownumber=ceil(log10(steps));
    
    for i=1:steps
        if mod(i,shownumber)==0
            waitbar(i / steps,hh,[num2str(i) '/' num2str(steps)]);
        end
        name=[cell2mat(pathsaved(3)) '\' trajsite '_' num2str(trajdate(i)) '_' trajmetero '_' trajheight];
        lati(i,1)=trajdate(i);
        longi(i,1)=lati(i,1);
        alti(i,1)=lati(i,1);
        if exist(name)
            textdata=textread(name,'','headerlines',head);
            if ~isempty(textdata)
                textdata=textdata';
                t=size(textdata);
                temp=lati(i,:);
                temp(2:t(2)+1)=textdata(10,:);
                lati(i,:)=temp;
                temp(2:t(2)+1)=textdata(11,:);
                longi(i,:)=temp;
                temp(2:t(2)+1)=textdata(12,:);
                alti(i,:)=temp;
            end
        end
    end
    close(hh);
    % save file
    filename=['.\trajdata\' trajsite '_' trajmetero '_' trajheight '.mat'];
    
    if exist(filename)
        load(filename);% Lati, Longi
        
        n1=size(Lati);
        n2=size(lati);
        if n1(2)>n2(2)
            nn=zeros(n2(1),n1(2)-n2(2));
            nn(:,:)=nan;
            lati=[lati nn];
            longi=[longi nn];
            alti=[alti nn];
        elseif n2(2)>n1(2)
            nn=zeros(n1(1),n2(2)-n1(2));
            nn(:,:)=nan;
            Lati=[Lati nn];
            Longi=[Longi nn];
            Alti=[Alti nn];
        end
        Lati=[Lati;lati];
        [a,b]=unique(Lati(:,1),'last');
        Lati=Lati(b,:);
        Lati=sortrows(Lati,1);
        
        Longi=[Longi;longi];
        [a,b]=unique(Longi(:,1),'last');
        Longi=Longi(b,:);
        Longi=sortrows(Longi,1);
        
        Alti=[Alti;alti];
        [a,b]=unique(Alti(:,1),'last');
        Alti=Alti(b,:);
        Alti=sortrows(Alti,1);
    else
        Lati=lati;
        Longi=longi;
        Alti=alti;
    end
    save(filename,'Lati','Longi','Alti');
    % delete files if op1=0
    if op1==0
        hhh = waitbar(0,'','name','Deleting Raw Files...');
        steps=trajnumber;
        shownumber=ceil(log10(steps));
        for i=1:steps
            if mod(i,shownumber)==0
                waitbar(i / steps,hhh,[num2str(i) '/' num2str(steps)]);
            end
            name=[cell2mat(pathsaved(3)) '\' trajsite '_' num2str(trajdate(i)) '_' trajmetero '_' trajheight];
            if exist(name)
                delete(name);
            end
        end
        close(hhh);
    end
end

delete([cell2mat(pathsaved(3)) '\count.txt']);
msgbox('Completed.');

function g_trajimport_Callback(hObject, eventdata, handles)
G_trajimport;

function g_pollutant_Callback(hObject, eventdata, handles)
G_data;

function g_trajdata_Callback(hObject, eventdata, handles)
G_trajdata;

function g_grid_Callback(hObject, eventdata, handles)
load('.\parameter.mat');
if ~exist('Grid','var')
    Grid=0.5;
end
grid=inputdlg('Please input new grid degree.','Grid',1,{num2str(Grid)});
grid=str2num(cell2mat(grid));
if isempty(grid)
    msgbox('Plsease enter number.','Error','error');
    return;
else
    Grid=grid;
    save('.\parameter.mat','Grid','-append');
    handles.grid=Grid;
end
guidata(hObject, handles);

function g_weight_Callback(hObject, eventdata, handles)
G_setweight;

function g_parameter_Callback(hObject, eventdata, handles)
G_setparameter;

function g_help_Callback(hObject, eventdata, handles)
winopen('.\Help.pdf');

function g_about_Callback(hObject, eventdata, handles)
msg={'                       TraPSA Software';
          '    Powered by Chuanlong Zhou @ Clarkson.';
          '                          Version 1.0'};
msgbox(msg,'About');


%-------------------------------

% basic analysis functions

%-------------------------------
function p=f_itemcheck(handles)
s=get(handles.g_addeditem,'string');
v=get(handles.g_addeditem,'value');
if isempty(s)
    p=0;
else
    p=1;
end

function g_figuredis_Callback(hObject, eventdata, handles)
p=size(handles.figures);
for i=1:p(2)
    set(handles.figures(i),'visible','off');
    g=get(handles.figures(i),'children');
    set(g,'visible','off');
    set(handles.legend(i),'visible','off');
end

temp=get(handles.g_figuredis,'value');
s=get(handles.g_figuredis,'string');
s=cell2mat(s(temp));
if isempty(strfind(s,'Wind Rose (km/h)')) && isempty(strfind(s,'CPF')) && isempty(strfind(s,'Trend'))
    set(handles.figures(temp),'visible','on');
    g=get(handles.figures(temp),'children');
    set(g,'visible','on');
elseif ~isempty(strfind(s,'CPF'))
    set(handles.legend(temp),'visible','on');
    g=get(handles.figures(temp),'children');
    set(g,'visible','on');
elseif ~isempty(strfind(s,'Trend'))
    set(handles.figures(temp),'visible','on');
    g=get(handles.figures(temp),'children');
    set(g,'visible','on');
    set(handles.legend(temp),'visible','on');
else
    g=get(handles.figures(temp),'children');
    set(g,'visible','on');
end

function g_figuredis_ButtonDownFcn(hObject, eventdata, handles)
p=size(handles.figures);
for i=1:p(2)
    set(handles.figures(i),'visible','off');
    g=get(handles.figures(i),'children');
    set(g,'visible','off');
    set(handles.legend(i),'visible','off');
end

temp=get(handles.g_figuredis,'value');

if p(2)==0
elseif p(2)==1
    delete(handles.figures(temp));
    handles.legend=[];
    handles.figures(temp)=[];
    set(handles.g_figuredis,'string',{''});
    set(handles.g_figuredis,'value',1);
else
    delete(handles.figures(temp));
    handles.figures(temp)=[];
    handles.legend(temp)=[];
    S=get(handles.g_figuredis,'string');
    S(temp)=[];
    set(handles.g_figuredis,'string',S);
    if length(S)<temp
        temp=length(S);
    end
    set(handles.g_figuredis,'value',temp);
    
    s=cell2mat(S(temp));
    if isempty(strfind(s,'Wind Rose (km/h)')) && isempty(strfind(s,'CPF')) && isempty(strfind(s,'Trend'))
        set(handles.figures(temp),'visible','on');
        g=get(handles.figures(temp),'children');
        set(g,'visible','on');
    elseif ~isempty(strfind(s,'CPF'))
        set(handles.legend(temp),'visible','on');
        g=get(handles.figures(temp),'children');
        set(g,'visible','on');
    elseif ~isempty(strfind(s,'Trend'))
        set(handles.figures(temp),'visible','on');
        g=get(handles.figures(temp),'children');
        set(g,'visible','on');
        set(handles.legend(temp),'visible','on');
    else
        g=get(handles.figures(temp),'children');
        set(g,'visible','on');
    end
end
guidata(hObject, handles);

function [list,nlist,temp]=f_plotpre(handles)
set(handles.text2,'visible','on');
% clear all
p=size(handles.figures);
for i=1:p(2)
    set(handles.figures(i),'visible','off');
    g=get(handles.figures(i),'children');
    set(g,'visible','off');
    set(handles.legend(i),'visible','off');
end

if isempty(handles.figures)
    list={};
    nlist=0;
else
    list=get(handles.g_figuredis,'string');
    nlist=size(list);
    nlist=nlist(1);
end

temp=get(handles.g_addeditem,'value');

function f_plotsuf(handles,list,nlist,k);
if k==0
    set(handles.figures(nlist),'visible','on');
end
if k==2
    set(handles.legend(nlist),'visible','on');
end
if k==3
    set(handles.figures(nlist),'visible','on');
    set(handles.legend(nlist),'visible','on');
end
g=get(handles.figures(nlist),'children');
set(g,'visible','on');
set(handles.g_figuredis,'string',list);
set(handles.g_figuredis,'value',nlist);

set(handles.text2,'visible','off');

function g_plottime_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    pause(0.01);
    for i=1:length(temp)
        date=cell2mat(addeditem(temp(i),3));
        date=datenum(num2str(date(:,1)),'yyyymmddHH');
        conc=cell2mat(addeditem(temp(i),4));
        t=[cell2mat(addeditem(temp(i),1)) ' - Time Series'];
        nlist=nlist+1;
        list(nlist)={t};
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
        handles.figuredata(nlist)={[str2num(datestr(date,'yyyymmddHH')) conc]};
        k=plot(date,conc,'.','markersize',3,'color',[0 0.45 0.74]);
        handles.legend(nlist)=legend(k);
        set(handles.legend(nlist),'visible','off');
        xlabel('Time');
        if cell2mat(addeditem(temp(i),7))==0
            ylabel([cell2mat(addeditem(temp(i),5)) ' (' cell2mat(addeditem(temp(i),6)) ')']);
        else
            ylabel([cell2mat(addeditem(temp(i),5))]);
        end
        title(t);
        datetick('x','mmm-yy','keepticks');
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    
    f_plotsuf(handles,list,nlist,0);
end
guidata(hObject, handles);

function g_plotmonthly_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    
    for i=1:length(temp)
        date=cell2mat(addeditem(temp(i),3));
        date=mod(fix(date(:,1)/10000),100);
        conc=cell2mat(addeditem(temp(i),4));
        t=[cell2mat(addeditem(temp(i),1)) ' - Monthly'];
        nlist=nlist+1;
        list(nlist)={t};
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
        handles.figuredata(nlist)={[date conc]};
        boxplot(conc,date);
        k=get(handles.figures(nlist),'children');
        handles.legend(nlist)=legend(k(1));
        set(handles.legend(nlist),'visible','off');
        xlabel('Month');
        if cell2mat(addeditem(temp(i),7))==0
            ylabel([cell2mat(addeditem(temp(i),5)) ' (' cell2mat(addeditem(temp(i),6)) ')']);
        else
            ylabel([cell2mat(addeditem(temp(i),5))]);
        end
        title(t);
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    
    f_plotsuf(handles,list,nlist,0);
end
guidata(hObject, handles);

function g_plotweekly_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    
    for i=1:length(temp)
        date=cell2mat(addeditem(temp(i),3));
        date=datenum(num2str(fix(date/100)),'yyyymmdd');
        date=weekday(date);
        date(find(date==1))=8;
        date=date-1;
        label=['Mon.';'Tue.';'Wed.';'Thu.';'Fir.';'Sat.';'Sun.'];
        L=unique(date);
        label=label(L,:);
        conc=cell2mat(addeditem(temp(i),4));
        t=[cell2mat(addeditem(temp(i),1)) ' - Weekly'];
        nlist=nlist+1;
        list(nlist)={t};
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
        handles.figuredata(nlist)={[date conc]};
        boxplot(conc,date);
        k=get(handles.figures(nlist),'children');
        handles.legend(nlist)=legend(k(1));
        set(handles.legend(nlist),'visible','off');
        set(handles.figures(nlist),'xticklabel',label);
        xlabel('Day');
        if cell2mat(addeditem(temp(i),7))==0
            ylabel([cell2mat(addeditem(temp(i),5)) ' (' cell2mat(addeditem(temp(i),6)) ')']);
        else
            ylabel([cell2mat(addeditem(temp(i),5))]);
        end
        title(t);
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    
    f_plotsuf(handles,list,nlist,0);
end
guidata(hObject, handles);

function g_plothourly_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    
    for i=1:length(temp)
        date=cell2mat(addeditem(temp(i),3));
        date=mod(date(:,1),100);
        conc=cell2mat(addeditem(temp(i),4));
        t=[cell2mat(addeditem(temp(i),1)) ' - Hourly'];
        nlist=nlist+1;
        list(nlist)={t};
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
        handles.figuredata(nlist)={[date conc]};
        boxplot(conc,date);
        k=get(handles.figures(nlist),'children');
        handles.legend(nlist)=legend(k(1));
        set(handles.legend(nlist),'visible','off');
        xlabel('Time');
        if cell2mat(addeditem(temp(i),7))==0
            ylabel([cell2mat(addeditem(temp(i),5)) ' (' cell2mat(addeditem(temp(i),6)) ')']);
        else
            ylabel([cell2mat(addeditem(temp(i),5))]);
        end
        title(t);
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    
    f_plotsuf(handles,list,nlist,0);
end
guidata(hObject, handles);

function g_plotdistribution_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    pause(0.01);
    for i=1:length(temp)
        conc=cell2mat(addeditem(temp(i),4));
        t=[cell2mat(addeditem(temp(i),1)) ' - Distribution'];
        nlist=nlist+1;
        list(nlist)={t};
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
        hist(conc);
        [counts,centers]=hist(conc);
        handles.figuredata(nlist)={[centers' counts']};
        k=get(handles.figures(nlist),'children');
        handles.legend(nlist)=legend(k(1));
        set(handles.legend(nlist),'visible','off');
        h=findobj(handles.figures(nlist),'Type','patch');
        h.FaceColor = [0 0.45 0.74];
        h.EdgeColor = 'w';
        ylabel('Frequence');
        if cell2mat(addeditem(temp(i),7))==0
            xlabel([cell2mat(addeditem(temp(i),5)) ' (' cell2mat(addeditem(temp(i),6)) ')']);
        else
            xlabel([cell2mat(addeditem(temp(i),5))]);
        end
        title(t);
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    
    f_plotsuf(handles,list,nlist,0);
end
guidata(hObject, handles);

function g_plotwindrose_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    
    for i=1:length(temp)
        nlist=nlist+1;
        lati1=cell2mat(addeditem(temp(i),8));
        lati2=lati1(:,2);
        lati1=lati1(:,1);
        longi1=cell2mat(addeditem(temp(i),9));
        longi2=longi1(:,2);
        longi1=longi1(:,1);
        direc=f_direc(lati2,longi2,lati1,longi1);
        speed=f_geodis(lati2,longi2,lati1,longi1);
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off');
        handles.figuredata(nlist)={[direc speed]};
        wind_rose(direc, speed, 'parent',handles.figures(nlist));
        k=get(handles.figures(nlist),'children');
        handles.legend(nlist)=legend(k(2));
        set(handles.legend(nlist),'visible','off');
        t=[cell2mat(addeditem(temp(i),1)) ' - Wind Rose (km/h)'];
        list(nlist)={t};
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    f_plotsuf(handles,list,nlist,1);
end
guidata(hObject, handles);

function g_CPF_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    load('.\parameter.mat');
    if ~exist('CPF','var')
        msgbox('Please set up CPF parameter.','Error','error');
        return;
    end
    
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    pause(0.01);
    for i=1:length(temp)
        t=[cell2mat(addeditem(temp(i),1)) ' - CPF'];
        nlist=nlist+1;
        list(nlist)={t};
        
        lati1=cell2mat(addeditem(temp(i),8));
        lati2=lati1(:,2);
        lati1=lati1(:,1);
        longi1=cell2mat(addeditem(temp(i),9));
        longi2=longi1(:,2);
        longi1=longi1(:,1);
        
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
        
        direc=f_direc(lati2,longi2,lati1,longi1);
        speed=f_geodis(lati2,longi2,lati1,longi1);
        n=size(direc);
        n=n(1);
        B=[0:30:360];
        
        conc=cell2mat(addeditem(temp(i),4));
        nondiscard=find(speed>=CPFdiscard);
        conc=[conc direc speed];
        conc=conc(nondiscard,:);
        conc=sortrows(conc,-1);
        n=fix(n*CPF);
        conc=conc(1:n,2);
        A=hist(conc,B);
        Temp=A';
        A(1)=A(1)+A(13);
        A(13)=A(1);
        f_polar(B*pi/180,A/n,'r');
        hold on;
        
        direc=direc(nondiscard);
        n=size(direc);
        n=n(1);
        A=hist(direc,B);
        Temp=[Temp A'];
        A(1)=A(1)+A(13);
        A(13)=A(1);
        f_polar(B*pi/180,A/n,'--');
        
        handles.figuredata(nlist)={[B' Temp]};
        
        g=get(handles.figures(nlist),'children');
        handles.legend(nlist)=legend([g(2) g(1)],'CPF','Wind Frequence',...
            'Position',[900 45 0 0],'handlevisibility','on');
        set(handles.legend(nlist),'visible','off');
        hold off;
        
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
        
    end
    f_plotsuf(handles,list,nlist,2);
end
guidata(hObject, handles);

function g_plottrend_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    [list,nlist,temp]=f_plotpre(handles);
    load('.\addeditem.mat');
    pause(0.01);
    for i=1:length(temp)
        date=cell2mat(addeditem(temp(i),3));
        date=datenum(num2str(date(:,1)),'yyyymmddHH');
        conc=cell2mat(addeditem(temp(i),4));
        t=[cell2mat(addeditem(temp(i),1)) ' - Trend'];
        nlist=nlist+1;
        list(nlist)={t};
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
        bls = regress(conc,[ones(size(date)) date]);
        [b,l]=f_sen([date,conc]);
        handles.figuredata(nlist)={[roundn(b*365,-2) roundn(bls(2)*365,-2)]};
        plot(date,conc,'.','markersize',3,'color',[0 0.45 0.74]);
        hold on;
        x=get(handles.figures(nlist),'xlim');
        y=get(handles.figures(nlist),'ylim');
        text( x(1)+(x(2)-x(1))/100*2,y(2)-(y(2)-y(1))/100*5, ['Sen''s slope: ' num2str(roundn(b*365,-2)) '/ year']);
        R=plot(x,bls(1)+bls(2)*x,'r','LineWidth',1);
        S=plot(x,b*x+l,'g','LineWidth',3);
        handles.legend(nlist)=legend([S R],'Sen''s Slope','OLS Slope',...
            'Position',[830 60 0 0],'handlevisibility','on');
        set(handles.legend(nlist),'visible','off');
        xlabel('Time');
        if cell2mat(addeditem(temp(i),7))==0
            ylabel([cell2mat(addeditem(temp(i),5)) ' (' cell2mat(addeditem(temp(i),6)) ')']);
        else
            ylabel([cell2mat(addeditem(temp(i),5))]);
        end
        title(t);
        hold off;
        datetick('x','mmm-yy','keepticks');
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    
    f_plotsuf(handles,list,nlist,3);
end
guidata(hObject, handles);

%-------------------------------

% map functions

%-------------------------------

function H=g_resetmap_Callback(hObject, eventdata, handles)
load('.\pathsaved.mat');
% check mapdata folder
if isempty(pathsaved)
    msgbox('Please set up map data path.','Error','error')
    return;
end
% clear map;
set(handles.text3,'visible','on');
axes(handles.g_map);
cla reset;
% reset map parameter
load('.\parameter.mat');
% create blank map
% set map
handles.g_map=worldmap([-90 90],[-180 180]);
setm(handles.g_map,'MapProjection',mapprojection);
setm(handles.g_map,'grid','off')
setm(handles.g_map,'frame','off')
setm(handles.g_map,'parallellabel','off') % close x axis
setm(handles.g_map,'meridianlabel','off') % close y axis
% read map data
a=dir(cell2mat(pathsaved(2)));
n=size(a);
% reset map display list
maptemp={};
handles.mapdis={};
handles.mapgrid={};
handles.gridfocus={};
handles.gridpeak={};
handles.gridpeak2={};
s=0;
for i=3:n(1)
    temp=a(i).name;
    temp=temp(end-2:end);
    if strcmpi(temp,'shp')
        s=s+1;
        maptemp(s)={['[X] ' a(i).name(1:end-4)]};
        temp=a(i).name;
        temp=[cell2mat(pathsaved(2)) '\' temp];
        p_states= shaperead(temp, 'UseGeoCoords', true);
        if strcmpi(p_states(1).Geometry,'Polygon')
            m=geoshow(temp, 'FaceColor', 'w');
            set(m.Children,'Facealpha',0);
            uistack(m,'bottom');
            set(m.Children,'ButtonDownFcn',@f_property);
            h.c=m;
            handles.mapdis(s)={h};
        elseif strcmpi(p_states(1).Geometry,'Point')
            m=geoshow(temp, 'marker','.',...
                'markersize',10,'MarkerEdgecolor','k');
            uistack(m,'top');
            set(m.Children,'ButtonDownFcn',@f_property);
            h.c=m;
            handles.mapdis(s)={h};
        else
            m=geoshow(temp, 'color','k');
            uistack(m,'top');
            set(m.Children,'ButtonDownFcn',@f_property);
            h.c=m;
            handles.mapdis(s)={h};
        end
        handles.mapgrid(s)={[]};
        handles.gridfocus(s)={[]};
        handles.gridpeak(s)={[]};
        handles.gridpeak2(s)={[]};
        handles.mapref(s)={[]};
    elseif strcmpi(temp,'tif')
        handles.tif=[handles.tif,{a(i).name(1:end-4)}];
        s=s+1;
        maptemp(s)={['[X] ' a(i).name(1:end-4)]};
        temp=a(i).name;
        temp=[cell2mat(pathsaved(2)) '\' temp];
        [grid,r]=geotiffread(temp);
        
        handles.mapgrid(s)={grid};
        h1=mapping(grid,r);
        set(h1,'HitTest','off');
        H1.c=h1;
        
        [h1,h2]=f_mapdot(0,0,'name','','type','none','size',1,'color','b');
        H2.c=[h1;h2];
        
        fgrid=f_focusgrid(grid);
        handles.gridfocus(s)={fgrid};
        h1=mapping(fgrid,r);
        set(h1,'HitTest','off');
        H3.c=h1;
        
        pgrid=peakgrid(grid,peaknumber);
        pgrid(:,1)=-90+(pgrid(:,1)-0.5)*Grid;
        pgrid(:,2)=-180+(pgrid(:,2)-0.5)*Grid;
        handles.gridpeak(s)={pgrid};
        [h1,h2]=f_mapdot(pgrid(:,1),pgrid(:,2),...
            'type','o','size',12,'color','b'); % P=1 means these points are in the same group
        set(h1,'ButtonDownFcn',@f_property);
        set(h2,'ButtonDownFcn',@f_property);
        H4.c=[h1;h2];
        
        pgrid2=peakgrid(fgrid,peaknumber);
        pgrid2(:,1)=-90+(pgrid2(:,1)-0.5)*Grid;
        pgrid2(:,2)=-180+(pgrid2(:,2)-0.5)*Grid;
        handles.gridpeak2(s)={pgrid2};
        [h1,h2]=f_mapdot(pgrid2(:,1),pgrid2(:,2),...
            'type','o','size',12,'color','b');
        set(h1,'ButtonDownFcn',@f_property);
        set(h2,'ButtonDownFcn',@f_property);
        H5.c=[h1;h2];
        
        uistack(H4.c,'top');
        uistack(H5.c,'top');
        handles.mapdis(s)={[H1;H2;H3;H4;H5]};
        f_visible(handles.mapdis(s),'off');
        handles.mapref(s)={r};
        
        temp=handles.mapdis{1,s};
        v=temp(2);
        if handles.Focus==0
            v=[v;temp(1)];
            if handles.Peak==1
                v=[v;temp(4)];
            end
        else
            v=[v;temp(3)];
            if handles.Peak==1
                v=[v;temp(5)];
            end
        end
        f_visible({v},'on');
        uistack(v(2).c,'top');
        if length(v)==3
            uistack(v(3).c,'top');
        end
        uistack(v(1).c,'top');
    end
end
handles.mapnumber=s;
% set center
f_setmap(mapcenter(1),mapcenter(2),30,35);

set(handles.g_mapdisplay,'string',maptemp);
set(handles.g_mapdisplay,'value',1);
set(handles.text3,'visible','off');
H=handles;
guidata(hObject, handles);

function g_mapdisplay_Callback(hObject, eventdata, handles)
nlist=get(handles.g_mapdisplay,'value');
s=get(handles.g_mapdisplay,'string');
temp2=cell2mat(s(nlist));

% if X; close this layer
if strcmp(temp2(2),'X')
    f_visible(handles.mapdis(nlist),'off');
    temp2(2)='O';
    s(nlist)={temp2};
    set(handles.g_mapdisplay,'string',s);
else
    % if O; open this layer
    % if not a grid map
    if ~f_check(temp2,handles)
        f_visible(handles.mapdis(nlist),'on');
        m=handles.mapdis{1,nlist};
        n=size(m);
        for i=1:n
            uistack(m(i).c,'top');
        end
    else
        % if a grid map
        n=size(s);
        % close other grid map
        for i=1:n
            name=cell2mat(s(i));
            if f_check(name,handles)
                if i~=nlist && strcmp(name(2),'X')
                    f_visible(handles.mapdis(i),'off');
                    name(2)='O';
                    s(i)={name};
                end
            end
        end
        set(handles.g_mapdisplay,'string',s);
        
        temp=handles.mapdis{1,nlist};
        v=temp(2);
        if handles.Focus==0
            v=[v;temp(1)];
            if handles.Peak==1
                v=[v;temp(4)];
            end
        else
            v=[v;temp(3)];
            if handles.Peak==1
                v=[v;temp(5)];
            end
        end
        f_visible({v},'on');
        uistack(v(2).c,'top');
        if length(v)==3
            uistack(v(3).c,'top');
        end
        uistack(v(1).c,'top');
    end
    temp2(2)='X';
    s(nlist)={temp2};
    set(handles.g_mapdisplay,'string',s);
end

guidata(hObject, handles);

function g_zoom_Callback(hObject, eventdata, handles)
if handles.zoom==0
    if handles.rotate3==1
        handles.rotate3=0;
        rotate3d off;
        set(handles.g_rotate,'BackgroundColor',[0.275 0.549 0.549]);
    end
    
    if handles.pan==1
        pan off;
        handles.pan=0;
        set(handles.g_pan,'BackgroundColor',[0.275 0.549 0.549]);
    end
    handles.zoom=1;
    handles.Z=zoom;
    handles.Z.Enable='on';
    handles.Z.RightClickAction='InverseZoom';
    set(handles.g_zoom,'BackgroundColor',[0.725 0.451 0.451]);
else
    handles.zoom=0;
    handles.Z.Enable='off';
    set(handles.g_zoom,'BackgroundColor',[0.275 0.549 0.549]);
end
guidata(hObject, handles);

function g_pan_Callback(hObject, eventdata, handles)
if handles.pan==0
    if handles.rotate3==1
        handles.rotate3=0;
        rotate3d off;
        set(handles.g_rotate,'BackgroundColor',[0.275 0.549 0.549]);
    end
    if handles.zoom==1
        handles.zoom=0;
        handles.Z.Enable='off';
        set(handles.g_zoom,'BackgroundColor',[0.275 0.549 0.549]);
    end
    pan on;
    handles.pan=1;
    set(handles.g_pan,'BackgroundColor',[0.725 0.451 0.451]);
else
    pan off;
    handles.pan=0;
    set(handles.g_pan,'BackgroundColor',[0.275 0.549 0.549]);
end
guidata(hObject, handles);

function g_rotate_Callback(hObject, eventdata, handles)
temp=get(handles.g_figuredis,'value');
axes(handles.figures(temp));
if handles.rotate3==0
    if handles.pan==1
        handles.pan=0;
        pan off;
        set(handles.g_pan,'BackgroundColor',[0.275 0.549 0.549]);
    end
    if handles.zoom==1
        handles.zoom=0;
        handles.Z.Enable='off';
        set(handles.g_zoom,'BackgroundColor',[0.275 0.549 0.549]);
    end
    rotate3d on;
    handles.rotate3=1;
    set(handles.g_rotate,'BackgroundColor',[0.725 0.451 0.451]);
else
    rotate3d off;
    handles.rotate3=0;
    set(handles.g_rotate,'BackgroundColor',[0.275 0.549 0.549]);
end
guidata(hObject, handles);

function g_maptext_Callback(hObject, eventdata, handles)
if length(handles.mapdis)>1
    a=inputdlg({'Text Content:';'Location (lat, lon):';'Marker (y/n):'},'Input',1,{'Text';'';'y'});
    
    list=get(handles.g_mapdisplay,'string');
    nlist=size(list);
    nlist=nlist(1);
    
    if isempty(cell2mat(a(2)))
        H2=gtext(cell2mat(a(1)));
        p=get(H2,'position');
        if strcmp(cell2mat(a(3)),'y')
            H1=plot(p(1),p(2),'marker','.','markersize',10,'color','k');
        else
            H1=plot(p(1),p(2),'marker','none','markersize',10,'color','k');
        end
    else
        l=cell2mat(a(2));
        index=find(l==',');
        lat=str2num(l(1:index-1));
        lon=str2num(l(index+1:end));
        if strcmp(cell2mat(a(3)),'y')
            [H1,H2]=f_mapdot(lat,lon,'name',a(1),'type','.','size',10,'color','k');
        else
            [H1,H2]=f_mapdot(lat,lon,'name',a(1),'type','none','size',10,'color','k');
        end
    end
    set(H1,'LineStyle','none');
    uistack(H1,'top');
    uistack(H2,'top');
    set(H1,'ButtonDownFcn',@f_property);
    set(H2,'ButtonDownFcn',@f_property);
    nlist=nlist+1;
    list(nlist)={['[X] ' cell2mat(a(1))]};
    h.c=[H1;H2];
    handles.mapdis(nlist)={h};
    handles.mapgrid(nlist)={[]};
    handles.gridfocus(nlist)={[]};
    handles.gridpeak(nlist)={[]};
    handles.gridpeak2(nlist)={[]};
    set(handles.g_mapdisplay,'string',list);
    set(handles.g_mapdisplay,'value',nlist);
end
guidata(hObject, handles);

function g_focus_Callback(hObject, eventdata, handles)
if ~isempty(handles.mapdis)
    if handles.Focus==0
        handles.Focus=1;
        set(handles.g_focus,'BackgroundColor',[0.725 0.451 0.451]);
        
        nlist=get(handles.g_mapdisplay,'value');
        s=get(handles.g_mapdisplay,'string');
        s=cell2mat(s(nlist));
        if f_check(s,handles) && s(2)=='X'
            f_visible(handles.mapdis(nlist),'off');
            temp=handles.mapdis{1,nlist};
            v=temp(2);
            v=[v;temp(3)];
            if handles.Peak==1
                v=[v;temp(5)];
            end
            f_visible({v},'on');
            uistack(v(2).c,'top');
            if length(v)==3
                uistack(v(3).c,'top');
            end
            uistack(v(1).c,'top');
        end
    else
        handles.Focus=0;
        set(handles.g_focus,'BackgroundColor',[0.275 0.549 0.549]);
        
        nlist=get(handles.g_mapdisplay,'value');
        s=get(handles.g_mapdisplay,'string');
        s=cell2mat(s(nlist));
        if f_check(s,handles) && s(2)=='X'
            f_visible(handles.mapdis(nlist),'off');
            temp=handles.mapdis{1,nlist};
            v=temp(2);
            v=[v;temp(1)];
            if handles.Peak==1
                v=[v;temp(4)];
            end
            f_visible({v},'on');
            uistack(v(2).c,'top');
            if length(v)==3
                uistack(v(3).c,'top');
            end
            uistack(v(1).c,'top');
        end
    end
end
guidata(hObject, handles);

function g_peak_Callback(hObject, eventdata, handles)
if ~isempty(handles.mapdis)
    if handles.Peak==0
        handles.Peak=1;
        set(handles.g_peak,'BackgroundColor',[0.725 0.451 0.451]);
        
        nlist=get(handles.g_mapdisplay,'value');
        s=get(handles.g_mapdisplay,'string');
        s=cell2mat(s(nlist));
        if f_check(s,handles) && s(2)=='X'
            f_visible(handles.mapdis(nlist),'off');
            temp=handles.mapdis{1,nlist};
            v=temp(2);
            if handles.Focus==0
                v=[v;temp(1);temp(4)];
            else
                v=[v;temp(3);temp(5)];
            end
            f_visible({v},'on');
            uistack(v(2).c,'top');
            if length(v)==3
                uistack(v(3).c,'top');
            end
            uistack(v(1).c,'top');
        end
    else
        handles.Peak=0;
        set(handles.g_peak,'BackgroundColor',[0.275 0.549 0.549]);
        
        nlist=get(handles.g_mapdisplay,'value');
        s=get(handles.g_mapdisplay,'string');
        s=cell2mat(s(nlist));
        if f_check(s,handles) && s(2)=='X'
            f_visible(handles.mapdis(nlist),'off');
            temp=handles.mapdis{1,nlist};
            v=temp(2);
            if handles.Focus==0
                v=[v;temp(1)];
            else
                v=[v;temp(3)];
            end
            f_visible({v},'on');
            uistack(v(2).c,'top');
            if length(v)==3
                uistack(v(3).c,'top');
            end
            uistack(v(1).c,'top');
        end
    end
end
guidata(hObject, handles);

function g_colormapeditor_Callback(hObject, eventdata, handles)
handles.Color=colorbar;
handles.Caxis=caxis;
setappdata(0, 'AD', handles);
uiwait(G_colormap);
H=getappdata(0,'AD');
ca=H.Caxis;
caxis(ca);
R=H.R;
colormap(R);
guidata(hObject, handles);

function f_property(hObject, eventdata, handles)
handles.property=hObject;
setappdata(0, 'AD', handles);

a=class(hObject);
index=find(a=='.');
a=a(index(end)+1:end);
if strcmp(a,'Text')
    b=questdlg('Do you want to change the position of text?','Text Position','Yes','No','No');
    if strcmp(b,'Yes')
        p=ginput(1);
        set(hObject,'position',p);
    end
    G_propertyt;
end

if strcmp(a,'Line')
    b=get(hObject,'LineStyle');
    if strcmp(b,'none')
        G_propertyp;
    else
        G_propertyl;
    end
end

if strcmp(a,'Patch')
    G_propertypa;
end

function p=f_check(s,handles)
p=[];
p=[p strfind(s,'Frequency')];
p=[p strfind(s,'CWT')];
p=[p strfind(s,'CFA')];
p=[p strfind(s,'PSCF')];
p=[p strfind(s,'RTWC')];
p=[p strfind(s,'SQTBA')];
p=[p strfind(s,'Inventory')];
for i=1:length(handles.tif)
    p=[p strfind(s,cell2mat(handles.tif(i)))];
end
if isempty(p)
    p=0;
else
    p=1;
end

function f_visible(H,v)
H=H{1,1};
n=length(H);
for i=1:n
    set(H(i).c,'visible',v);
end

%-------------------------------

% trajectory based analysis functions

%-------------------------------

function [conc,lati,longi,name,sitela,sitelo,sitename,Index]=f_getdata(handles,A)
load('.\addeditem.mat');
load('.\sitelist');
temp=get(handles.g_addeditem,'value');
n=length(temp);
conc={};
lati={};
longi={};
name={};
nn=[];
for i=1:n
    name(i)={['[O] ' cell2mat(addeditem(temp(i),1)) ' - ' A]};
    if i==1
        nn=['[X] ' cell2mat(addeditem(temp(i),1))];
    else
        nn=[nn '; ' cell2mat(addeditem(temp(i),1))];
    end
    conc(i)=addeditem(temp(i),4);
    if strcmp(A,'PSCF')
        load('.\parameter.mat','PSCF');
        tconc=cell2mat(conc(i));
        pn=length(tconc);
        pn=fix(pn*PSCF);
        pc=sortrows(tconc,-1);
        pc=pc(pn);
        index1=find(tconc<pc);
        index2=find(tconc>=pc);
        tconc(index1)=0;
        tconc(index2)=1;
        conc(i)={tconc};
    end
    lati(i)=addeditem(temp(i),8);
    longi(i)=addeditem(temp(i),9);
end

Index=inf;

a='Yes';
% conbimed or seperate
if n>1
    a=questdlg('Do you want to seperate these items ?','Multi-item Selected.','Yes','No','Yes');
    % conbine data
    if strcmp(a,'No')
        co=[];
        la=[];
        lo=[];
        if strcmp(A,'SQTBA')
            Index=[];
        end
        for i=1:n
            if i==1
                Index(i)=length(cell2mat(conc(i)));
            else
                Index(i)=Index(i-1)+length(cell2mat(conc(i)));
            end
            co=f_cat(co,cell2mat(conc(i)));
            la=f_cat(la,cell2mat(lati(i)));
            lo=f_cat(lo,cell2mat(longi(i)));
        end
        conc={co};
        lati={la};
        longi={lo};
        name={[nn ' - ' A]};
    end
end

sitela={};
sitelo={};
sitename={};
if strcmp(a,'No')
    la=[];
    lo=[];
    nn={};
    for i=1:n
        s=addeditem(temp(i),2);
        s=cell2mat(s{1,1});
        index=find(s==',');
        index=index(1);
        s=s(1:index-1);
        k=size(sitelist);
        for j=1:k(1)
            if strcmp(cell2mat(sitelist(j,1)),s)
                L=cell2mat(sitelist(j,2));
                la(i)=L(1);
                lo(i)=L(2);
                nn(i)=sitelist(j,1);
            end
        end
    end
    sitela={la};
    sitelo={lo};
    sitename={nn};
else
    for i=1:n
        s=addeditem(temp(i),2);
        s=cell2mat(s{1,1});
        index=find(s==',');
        index=index(1);
        s=s(1:index-1);
        k=size(sitelist);
        for j=1:k(1)
            if strcmp(cell2mat(sitelist(j,1)),s)
                L=cell2mat(sitelist(j,2));
                sitela(i)={L(1)};
                sitelo(i)={L(2)};
                sitename(i)={sitelist(j,1)};
            end
        end
    end
end

function [list,nlist]=f_clearmap(H)
list=get(H.g_mapdisplay,'string');
nlist=size(list);
nlist=nlist(1);
temp1=get(H.g_mapdisplay,'string');
for i=1:nlist
    temp2=cell2mat(temp1(i));
    if f_check(temp2,H)
        f_visible(H.mapdis(i),'off');
        temp2(2)='O';
        temp1(i)={temp2};
    end
end
list=temp1;
set(H.g_mapdisplay,'string',temp1);

function r=f_weight(m,n,p)
% m, need weight
% n, endpoint number
% p weight factor

l=p(:,1);
p=p(:,2);

avg=sum(sum(n))/length(find(n~=0));
l=l*avg;

index=cell(length(l),1);
for i=1:length(l)
    index(i)={find(n<=l(i))};
end

%{
s=size(m);
r=m;
for i=1:s(1)
    for j=1:s(2)
        index=find(n(i,j)<=l);
        if ~isempty(index)
            index=p(index(1));
            r(i,j)=r(i,j)*index;
        end
    end
end
%}

m(index{1,1})=m(index{1,1})*p(1);
for i=2:length(l)
    temp=setdiff(index{i,1},index{i-1,1});
    m(temp)=m(temp)*p(i);
end
r=m;

function H=f_object(handles,nlist,Grid,mgrid,sitela,sitelo,sitename,l)
load('.\parameter.mat');

handles.mapgrid(nlist)={mgrid};
% H1: original grid
r=georasterref('RasterSize', size(mgrid), 'Latlim', [-90 90], 'Lonlim', [-180 180]);
h1=mapping(mgrid,r);
set(h1,'HitTest','off');
H1.c=h1;
% H2: site name
[h1,h2]=f_mapdot(cell2mat(sitela(l)),cell2mat(sitelo(l)),...
    'name',sitename{1,l},'type','.','size',12,'color','b');
set(h1,'ButtonDownFcn',@f_property);
set(h2,'ButtonDownFcn',@f_property);
H2.c=[h1;h2];
% H3: grid focus on original grid
fgrid=f_focusgrid(mgrid);
handles.gridfocus(nlist)={fgrid};
r=georasterref('RasterSize', size(fgrid), 'Latlim', [-90 90], 'Lonlim', [-180 180]);
h1=mapping(fgrid,r);
set(h1,'HitTest','off');
H3.c=h1;
% H4: peak for H0
pgrid=peakgrid(mgrid,peaknumber);
if ~isempty(pgrid)
    pgrid(:,1)=-90+(pgrid(:,1)-0.5)*Grid;
    pgrid(:,2)=-180+(pgrid(:,2)-0.5)*Grid;
    handles.gridpeak(nlist)={pgrid};
    [h1,h2]=f_mapdot(pgrid(:,1),pgrid(:,2),...
        'type','o','size',12,'color','b');
    set(h1,'ButtonDownFcn',@f_property);
    set(h2,'ButtonDownFcn',@f_property);
    H4.c=[h1;h2];
else
    handles.gridpeak(nlist)={pgrid};
    H4.c=[];
end
% H5: peak for H3
pgrid2=peakgrid(fgrid,peaknumber);
if ~isempty(pgrid2)
    pgrid2(:,1)=-90+(pgrid2(:,1)-0.5)*Grid;
    pgrid2(:,2)=-180+(pgrid2(:,2)-0.5)*Grid;
    handles.gridpeak2(nlist)={pgrid2};
    [h1,h2]=f_mapdot(pgrid2(:,1),pgrid2(:,2),...
        'type','o','size',12,'color','b');
    set(h1,'ButtonDownFcn',@f_property);
    set(h2,'ButtonDownFcn',@f_property);
    H5.c=[h1;h2];
else
    handles.gridpeak2(nlist)={pgrid2};
    H5.c=[];
end

uistack(H2.c,'top');
handles.mapdis(nlist)={[H1;H2;H3;H4;H5]};
handles.mapref(nlist)={r};
f_visible(handles.mapdis(nlist),'off');

H=handles;

function f_mapsuf(handles,nlist,list)

temp=handles.mapdis{1,nlist};
v=temp(2);
if handles.Focus==0
    v=[v;temp(1)];
    if handles.Peak==1
        v=[v;temp(4)];
    end
else
    v=[v;temp(3)];
    if handles.Peak==1
        v=[v;temp(5)];
    end
end
f_visible({v},'on');
uistack(v(2).c,'top');
if length(v)==3
    uistack(v(3).c,'top');
end
uistack(v(1).c,'top');

t=cell2mat(list(nlist));
t(2)='X';
list(nlist)={t};
set(handles.g_mapdisplay,'string',list);
set(handles.g_mapdisplay,'value',nlist);

set(handles.text3,'visible','off');

function g_frequency_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    load('.\parameter.mat');
    % create a new map if no map created
    if isempty(handles.mapdis)
        handles=g_resetmap_Callback(hObject, eventdata, handles);
        set(handles.text3,'visible','on');
    end
    [list,nlist]=f_clearmap(handles);
    
    %check and get data
    [conc,lati,longi,name,sitela,sitelo,sitename]=f_getdata(handles,'Frequency');
    
    % calculate
    n=length(lati);
    for l=1:n
        nlist=nlist+1;
        list(nlist)=name(l);
        [la,lo]=f_corrd2grid(cell2mat(lati(l)),cell2mat(longi(l)),Grid);
        nn=size(la);
        mgrid=zeros(fix(180/Grid),fix(360/Grid));
        for i=1:nn(1)
            for j=1:nn(2)
                if ~isnan(la(i,j))
                    mgrid(la(i,j),lo(i,j))=mgrid(la(i,j),lo(i,j))+1;
                end
            end
        end
        mgrid=log10(mgrid);
        
        handles=f_object(handles,nlist,Grid,mgrid,sitela,sitelo,sitename,l);
    end
    f_mapsuf(handles,nlist,list);
end
guidata(hObject, handles);

function g_CWT_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    % check parameter
    load('.\parameter.mat');
    p=[];
    if exist('Weightapplied','var')
        if Weightapplied(2)==1
            p=Weight;
        end
    end
    
    % create a new map if no map created
    if isempty(handles.mapdis)
        handles=g_resetmap_Callback(hObject, eventdata, handles);
        set(handles.text3,'visible','on');
    end
    [list,nlist]=f_clearmap(handles);
    
    %check and get data
    [conc,lati,longi,name,sitela,sitelo,sitename]=f_getdata(handles,'CWT');
    
    % calculate
    n=length(lati);
    for l=1:n
        nlist=nlist+1;
        list(nlist)=name(l);
        [la,lo]=f_corrd2grid(cell2mat(lati(l)),cell2mat(longi(l)),Grid);
        co=cell2mat(conc(l));
        nn=size(la);
        mgrid=zeros(fix(180/Grid),fix(360/Grid));
        top=mgrid;
        for i=1:nn(1)
            for j=1:nn(2)
                if ~isnan(la(i,j))
                    top(la(i,j),lo(i,j))=top(la(i,j),lo(i,j))+co(i);
                    mgrid(la(i,j),lo(i,j))=mgrid(la(i,j),lo(i,j))+1;
                end
            end
        end
        ngrid=mgrid;
        mgrid=top./mgrid;
        if ~isempty(p)
            mgrid=f_weight(mgrid,ngrid,p);
        end
        
        handles=f_object(handles,nlist,Grid,mgrid,sitela,sitelo,sitename,l);
    end
    
    f_mapsuf(handles,nlist,list);
end
guidata(hObject, handles);

function g_CFA_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    % check parameter
    load('.\parameter.mat');
    p=[];
    if exist('Weightapplied','var')
        if Weightapplied(1)==1
            p=Weight;
        end
    end
    
    % create a new map if no map created
    if isempty(handles.mapdis)
        handles=g_resetmap_Callback(hObject, eventdata, handles);
        set(handles.text3,'visible','on');
    end
    [list,nlist]=f_clearmap(handles);
    
    %check and get data
    [conc,lati,longi,name,sitela,sitelo,sitename]=f_getdata(handles,'CFA');
    
    % calculate
    n=length(lati);
    for l=1:n
        nlist=nlist+1;
        list(nlist)=name(l);
        [la,lo]=f_corrd2grid(cell2mat(lati(l)),cell2mat(longi(l)),Grid);
        co=cell2mat(conc(l));
        nn=size(la);
        mgrid=zeros(fix(180/Grid),fix(360/Grid));
        top=mgrid;
        for i=1:nn(1)
            for j=1:nn(2)
                if ~isnan(la(i,j))
                    top(la(i,j),lo(i,j))=top(la(i,j),lo(i,j))+log10(co(i));
                    mgrid(la(i,j),lo(i,j))=mgrid(la(i,j),lo(i,j))+1;
                end
            end
        end
        ngrid=mgrid;
        mgrid=top./mgrid;
        if ~isempty(p)
            mgrid=f_weight(mgrid,ngrid,p);
        end
        
        handles=f_object(handles,nlist,Grid,mgrid,sitela,sitelo,sitename,l);
    end
    
    f_mapsuf(handles,nlist,list);
end
guidata(hObject, handles);

function g_PSCF_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    % check parameter
    load('.\parameter.mat');
    if ~exist('PSCF','var')
        msgbox('Please set up PSCF parameter.','Error','error');
        return;
    end
    p=[];
    if exist('Weightapplied','var')
        if Weightapplied(3)==1
            p=Weight;
        end
    end
    
    % create a new map if no map created
    if isempty(handles.mapdis)
        handles=g_resetmap_Callback(hObject, eventdata, handles);
        set(handles.text3,'visible','on');
    end
    [list,nlist]=f_clearmap(handles);
    
    %check and get data
    [conc,lati,longi,name,sitela,sitelo,sitename]=f_getdata(handles,'PSCF');
    
    % calculate
    n=length(lati);
    for l=1:n
        nlist=nlist+1;
        list(nlist)=name(l);
        [la,lo]=f_corrd2grid(cell2mat(lati(l)),cell2mat(longi(l)),Grid);
        co=cell2mat(conc(l));
        nn=size(la);
        mgrid=zeros(fix(180/Grid),fix(360/Grid));
        top=mgrid;
        for i=1:nn(1)
            for j=1:nn(2)
                if ~isnan(la(i,j))
                    top(la(i,j),lo(i,j))=top(la(i,j),lo(i,j))+co(i);
                    mgrid(la(i,j),lo(i,j))=mgrid(la(i,j),lo(i,j))+1;
                end
            end
        end
        ngrid=mgrid;
        mgrid=top./mgrid;
        if ~isempty(p)
            mgrid=f_weight(mgrid,ngrid,p);
        end
        
        handles=f_object(handles,nlist,Grid,mgrid,sitela,sitelo,sitename,l);
    end
    
    f_mapsuf(handles,nlist,list);
end
guidata(hObject, handles);

function g_RTWC_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    % check parameter
    load('.\parameter.mat');
    p=[];
    if exist('Weightapplied','var')
        if Weightapplied(4)==1
            p=Weight;
        end
    end
    
    % create a new map if no map created
    if isempty(handles.mapdis)
        handles=g_resetmap_Callback(hObject, eventdata, handles);
        set(handles.text3,'visible','on');
    end
    [list,nlist]=f_clearmap(handles);
    
    %check and get data
    [conc,lati,longi,name,sitela,sitelo,sitename]=f_getdata(handles,'RTWC');
    
    % calculate
    n=length(lati);
    for l=1:n
        nlist=nlist+1;
        list(nlist)=name(l);
        [la,lo]=f_corrd2grid(cell2mat(lati(l)),cell2mat(longi(l)),Grid);
        co=cell2mat(conc(l));
        nn=size(la);
        mgrid=zeros(fix(180/Grid),fix(360/Grid));
        top=mgrid;
        for i=1:nn(1)
            for j=1:nn(2)
                if ~isnan(la(i,j))
                    top(la(i,j),lo(i,j))=top(la(i,j),lo(i,j))+co(i);
                    mgrid(la(i,j),lo(i,j))=mgrid(la(i,j),lo(i,j))+1;
                end
            end
        end
        ngrid=mgrid;
        mgrid=top./mgrid;
        
        ii=1;
        while ii==1
            XX=mgrid;
            top=zeros(fix(180/Grid),fix(360/Grid));
            bot=top;
            ct=zeros(nn(1));
            for i=1:nn(1)
                s=0;
                for j=1:nn(2)
                    if ~isnan(la(i,j)) && ~isnan(XX(la(i,j),lo(i,j)))
                        ct(i)=ct(i)+XX(la(i,j),lo(i,j));
                        s=s+1;
                    end
                end
                ct(i)=ct(i)/s;
            end
            
            for i=1:nn(1)
                for j=1:nn(2)
                    if ~isnan(la(i,j)) && ~isnan(XX(la(i,j),lo(i,j)))
                        top(la(i,j),lo(i,j))=top(la(i,j),lo(i,j))+co(i)*XX(la(i,j),lo(i,j))/ct(i);
                        bot(la(i,j),lo(i,j))=bot(la(i,j),lo(i,j))+1;
                    end
                end
            end
            mgrid=top./bot;
            
            if abs(mean(XX(~isnan(XX)))-mean(mgrid(~isnan(mgrid))))/mean(mgrid(~isnan(mgrid)))<0.001
                ii=0;
            end
            
        end
        
        if ~isempty(p)
            mgrid=f_weight(mgrid,ngrid,p);
        end
        
        handles=f_object(handles,nlist,Grid,mgrid,sitela,sitelo,sitename,l);
    end
    
    f_mapsuf(handles,nlist,list);
end
guidata(hObject, handles);

function g_selectedevent_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    setappdata(0, 'AD', handles);
    uiwait(G_selectevent);
    H=getappdata(0,'AD');
    E=size(handles.selectedevent);
    handles.selectedevent=[handles.selectedevent;H.selectedevent];
    
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    % create a new map if no map created
    if isempty(handles.mapdis)
        handles=g_resetmap_Callback(hObject, eventdata, handles);
        set(handles.text3,'visible','on');
    end
    [list,nlist]=f_clearmap(handles);
    
    % plot on map
    axes(handles.g_map);
    n=size(H.selectedevent);
    n=n(1);
    for i=1:n
        nlist=nlist+1;
        handles.selectedevent{E(1)+i,8}=nlist;
        list(nlist)={['[O] ' cell2mat(H.selectedevent{i,1}) '- Event']};
        lat=H.selectedevent{i,4};
        lat=cell2mat(lat);
        lon=H.selectedevent{i,5};
        lon=cell2mat(lon);
        m=size(lat);
        H0=[];
        for j=1:m(1)
            if H.showendpoint==0
                H1=geoshow(lat(j,:),lon(j,:),'color','k','LineWidth',1.5);
            else
                H1=geoshow([0 0],[100 10],'color','k','LineWidth',1.5,'Marker','o');
            end
            lab=H.selectedevent{i,3};
            lab=lab{1,1};
            lab=cell2mat(lab(j));
            index=find(lab=='_');
            lab=lab(index+1:end);
            La=lat(j,:);
            La=find(~isnan(La));
            H2=textm(lat(j,La(end)),lon(j,La(end))+0.5, lab);
            uistack(H1,'top');
            uistack(H2,'top');
            set(H1,'ButtonDownFcn',@f_property);
            set(H2,'ButtonDownFcn',@f_property);
            H0=[H0;H1;H2];
        end
        h.c=H0;
        handles.mapdis(nlist)={h};
        handles.mapgrid(nlist)={[]};
        f_visible(handles.mapdis(1,nlist),'off');
    end
    
    f_visible(handles.mapdis(1,nlist),'on');
    t=cell2mat(list(nlist));
    t(2)='X';
    list(nlist)={t};
    set(handles.g_mapdisplay,'string',list);
    set(handles.g_mapdisplay,'value',nlist);
    
    set(handles.text3,'visible','off');
    
    % plot 3D trajectory
    set(handles.text2,'visible','on');
    % clear all
    p=size(handles.figures);
    for i=1:p(2)
        set(handles.figures(i),'visible','off');
        g=get(handles.figures(i),'children');
        set(g,'visible','off');
        set(handles.legend(i),'visible','off');
    end
    
    if isempty(handles.figures)
        list={};
        nlist=0;
    else
        list=get(handles.g_figuredis,'string');
        nlist=size(list);
        nlist=nlist(1);
    end
    
    for i=1:n
        nlist=nlist+1;
        list(nlist)=H.selectedevent{i,1};
        handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0.03 0 1.2 0.9],'visible','off','box','on');
        lat=H.selectedevent{i,4};
        lat=cell2mat(lat);
        lon=H.selectedevent{i,5};
        lon=cell2mat(lon);
        alt=H.selectedevent{i,6};
        alt=cell2mat(alt);
        m=size(lat);
        for j=1:m(1)
            plot3(lat(j,:),lon(j,:),alt(j,:),'*-');
            hold on;
            k=plot3(lat(j,1),lon(j,1),alt(j,1),'ok');
            handles.legend(nlist)=legend(k);
            set(handles.legend(nlist),'visible','off');
            lab=H.selectedevent{i,3};
            lab=lab{1,1};
            lab=cell2mat(lab(j));
            index=find(lab=='_');
            lab=lab(index+1:end);
            lab(find(lab=='_'))='-';
            text(lat(j,end),lon(j,end),alt(j,end),lab);
        end
        xlabel Latitude;
        ylabel Longitude;
        zlabel Altitude;
        t=cell2mat(H.selectedevent{i,1});
        t(find(t=='_'))='-';
        title(t);
        hold off;
        set(handles.figures(nlist),'visible','off');
        g=get(handles.figures(nlist),'children');
        set(g,'visible','off');
    end
    
    % sign on time series
    for i=1:n
        name=[cell2mat(H.selectedevent{i,1}) '_'];
        index=find(name=='_');
        index=index(1);
        name=name(1:index-1);
        load('.\addeditem.mat');
        N=size(addeditem);
        N=N(1);
        for j=1:N
            if strcmp(name, addeditem{j,1})
                N=j;
            end
        end
        
        name=[name ' - Time Series'];
        p=0;
        for j=1:nlist
            if strcmp(name, cell2mat(list(j)))
                p=j;
            end
        end
        
        if p==0
            nlist=nlist+1;
            list(nlist)={name};
            handles.figures(nlist)=axes('parent',handles.g_plot,'outerposition',[0 0 1 0.90],'visible','off','box','on');
            conc=H.selectedevent{i,7};
            conc=cell2mat(conc);
            date=conc(:,1);
            index=H.selectedevent{i,2};
            index=cell2mat(index);
            index=find(ismember(date,index));
            date=datenum(num2str(date(:,1)),'yyyymmddHH');
            conc=conc(:,2);
            plot(date,conc,'.','markersize',3,'color',[0 0.45 0.74]);
            hold on;
            k=plot(date(index),conc(index),'o','markersize',5,'color','r');
            handles.legend(nlist)=legend(k);
            set(handles.legend(nlist),'visible','off');
            xlabel('Time');
            if cell2mat(addeditem(N,7))==0
                ylabel([cell2mat(addeditem(N,5)) ' (' cell2mat(addeditem(N,6)) ')']);
            else
                ylabel([cell2mat(addeditem(N,5))]);
            end
            title(name);
            datetick('x','mmm-yy','keepticks');
            hold off;
            set(handles.figures(nlist),'visible','off');
            g=get(handles.figures(nlist),'children');
            set(g,'visible','off');
        else
            axes(handles.figures(p));
            hold on;
            conc=H.selectedevent{i,7};
            conc=cell2mat(conc);
            date=conc(:,1);
            index=H.selectedevent{i,2};
            index=cell2mat(index);
            index=find(ismember(date,index));
            date=datenum(num2str(date(:,1)),'yyyymmddHH');
            conc=conc(:,2);
            plot(date(index),conc(index),'o','markersize',5,'color','r');
            hold off;
            set(handles.figures(p),'visible','off');
            g=get(handles.figures(p),'children');
            set(g,'visible','off');
        end
    end
    set(handles.figures(nlist),'visible','on');
    g=get(handles.figures(nlist),'children');
    set(g,'visible','on');
    set(handles.g_figuredis,'string',list);
    set(handles.g_figuredis,'value',nlist);
    
    axes(handles.g_map);
    
    set(handles.text2,'visible','off');
end
guidata(hObject, handles);

function g_SQTBA_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    % check parameter
    load('.\parameter.mat');
    p=[];
    if exist('Weightapplied','var')
        if Weightapplied(5)==1
            p=Weight;
        end
    end
    
    % create a new map if no map created
    if isempty(handles.mapdis)
        handles=g_resetmap_Callback(hObject, eventdata, handles);
        set(handles.text3,'visible','on');
    end
    [list,nlist]=f_clearmap(handles);
    
    %check and get data
    [conc,lati,longi,name,sitela,sitelo,sitename,Index]=f_getdata(handles,'SQTBA');
    n=length(lati);
    
    for l=1:n
        nlist=nlist+1;
        list(nlist)=name(l);
        La=cell2mat(lati(l));
        Lo=cell2mat(longi(l));
        [la,lo]=f_corrd2grid(cell2mat(lati(l)),cell2mat(longi(l)),Grid);
        co=cell2mat(conc(l));
        nn=size(la);
        k=1;
        X=cell2mat(sitela(l));
        X=X(k);
        Y=cell2mat(sitelo(l));
        Y=Y(k);
        index=Index(k);
        mgrid=zeros(fix(180/Grid),fix(360/Grid));
        top=mgrid;
        bottom=mgrid;
        ngrid=mgrid;
        for i=1:nn(1)
            for j=1:nn(2)
                if ~isnan(la(i,j))
                    if i>index
                        k=k+1;
                        X=cell2mat(sitela(l));
                        X=X(k);
                        Y=cell2mat(sitelo(l));
                        Y=Y(k);
                        index=Index(k);
                    end
                    v=(X-La(i,j))^2+(Y-Lo(i,j))^2;
                    if j==1
                        T=1;
                    else
                        T=1/5.4/(j-1)/sqrt(2*3.14*v)*(erfc(1/5.4/(j-1)*sqrt(v/2)));
                    end
                    top(la(i,j),lo(i,j))=top(la(i,j),lo(i,j))+T*co(i);
                    bottom(la(i,j),lo(i,j))=bottom(la(i,j),lo(i,j))+T;
                    ngrid(la(i,j),lo(i,j))=ngrid(la(i,j),lo(i,j))+1;
                end
            end
        end
        mgrid=top./bottom;
        
        if ~isempty(p)
            mgrid=f_weight(mgrid,ngrid,p);
        end
        
        handles=f_object(handles,nlist,Grid,mgrid,sitela,sitelo,sitename,l);
    end
    
    f_mapsuf(handles,nlist,list);
end
guidata(hObject, handles);

function g_emissioninventory_Callback(hObject, eventdata, handles)
set(handles.text3,'visible','on');
axes(handles.g_map);

[filename,filepath]=uigetfile('*.xls;*.xlsx;*.csv','Please select a file');
[num,txt,raw] = xlsread([filepath '\' filename]);

load('.\parameter.mat');

% create a new map if no map created
if isempty(handles.mapdis)
    handles=g_resetmap_Callback(hObject, eventdata, handles);
    set(handles.text3,'visible','on');
end
[list,nlist]=f_clearmap(handles);

nlist=nlist+1;

la=num(:,1);
lo=num(:,2);
[la,lo]=f_corrd2grid(la,lo,Grid);
c=num(:,3);
mgrid=zeros(fix(180/Grid),fix(360/Grid));
n=length(la);
for i=1:n
    mgrid(la(i),lo(i))=mgrid(la(i),lo(i))+c(i);
end
mgrid=log10(mgrid);

r=georasterref('RasterSize', size(mgrid), 'Latlim', [-90 90], 'Lonlim', [-180 180]);
handles.mapgrid(nlist)={mgrid};
h1=mapping(mgrid,r);
set(h1,'HitTest','off');
H1.c=h1;

[h1,h2]=f_mapdot(0,0,'name','','type','none','size',1,'color','b');
H2.c=[h1;h2];

r=georasterref('RasterSize', size(mgrid), 'Latlim', [-90 90], 'Lonlim', [-180 180]);
fgrid=f_focusgrid(mgrid);
handles.gridfocus(nlist)={fgrid};
h1=mapping(fgrid,r);
set(h1,'HitTest','off');
H3.c=h1;

pgrid=peakgrid(mgrid,peaknumber);
pgrid(:,1)=-90+(pgrid(:,1)-0.5)*Grid;
pgrid(:,2)=-180+(pgrid(:,2)-0.5)*Grid;
handles.gridpeak(nlist)={pgrid};
[h1,h2]=f_mapdot(pgrid(:,1),pgrid(:,2),...
    'type','o','size',12,'color','b','P',1); % P=1 means these points are in the same group
set(h1,'ButtonDownFcn',@f_property);
set(h2,'ButtonDownFcn',@f_property);
H4.c=[h1;h2];

pgrid2=peakgrid(fgrid,peaknumber);
pgrid2(:,1)=-90+(pgrid2(:,1)-0.5)*Grid;
pgrid2(:,2)=-180+(pgrid2(:,2)-0.5)*Grid;
handles.gridpeak2(nlist)={pgrid2};
[h1,h2]=f_mapdot(pgrid2(:,1),pgrid2(:,2),...
    'type','o','size',12,'color','b','P',1);
set(h1,'ButtonDownFcn',@f_property);
set(h2,'ButtonDownFcn',@f_property);
H5.c=[h1;h2];

uistack(H2.c,'top');
handles.mapdis(nlist)={[H1;H2;H3;H4;H5]};
handles.mapref(nlist)={r};
f_visible(handles.mapdis(nlist),'off');
list(nlist)={['[X] ' raw{1,1} '- Inventory']};

f_mapsuf(handles,nlist,list);

guidata(hObject, handles);

%-------------------------------

% other

%-------------------------------


function g_additem_Callback(hObject, eventdata, handles)
load('.\sitelist')
if ~isempty(sitelist)
    uiwait(G_additem);
    load('.\addeditem');
    if ~isempty(addeditem)
        s=addeditem(:,1);
        set(handles.g_addeditem,'string',s);
        s=size(addeditem);
        set(handles.g_addeditem,'value',s(1));
    else
        set(handles.g_addeditem,'string',addeditem(:,1));
        set(handles.g_addeditem,'value',1);
    end
end

function g_deletitem_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    temp=get(handles.g_addeditem,'value');
    load('.\addeditem.mat');
    addeditem(temp,:)=[];
    if ~isempty(addeditem)
        s=addeditem(:,1);
        set(handles.g_addeditem,'string',s);
        s=size(addeditem);
        set(handles.g_addeditem,'value',s(1));
    else
        set(handles.g_addeditem,'string',addeditem(:,1));
        set(handles.g_addeditem,'value',1);
    end
    save('.\addeditem.mat','addeditem');
end

function g_detail_Callback(hObject, eventdata, handles)
if f_itemcheck(handles)
    temp=get(handles.g_addeditem,'value');
    load('.\addeditem.mat');
    name=addeditem(temp,1);
    msg=addeditem(temp,2);
    for i=1:length(temp)
        msgbox(msg{i,:},[cell2mat(name(i))]);
    end
end

function g_mapdisplay_ButtonDownFcn(hObject, eventdata, handles)
p=size(handles.mapdis);

temp=get(handles.g_mapdisplay,'value');

if p(2)~=0
    a=handles.mapdis{1,temp};
end

if p(2)==0
elseif p(2)==1
    for i=1:length(a)
        delete(a(i).c);
    end
    handles.mapdis(temp)=[];
    handles.mapgrid(temp)=[];
    set(handles.g_mapdisplay,'string',{''});
    set(handles.g_mapdisplay,'value',1);
else
    for i=1:length(a)
        delete(a(i).c);
    end
    handles.mapdis(temp)=[];
    handles.mapgrid(temp)=[];
    S=get(handles.g_mapdisplay,'string');
    S(temp)=[];
    set(handles.g_mapdisplay,'string',S);
    if length(S)<temp
        temp=length(S);
    end
    set(handles.g_mapdisplay,'value',temp);
end
guidata(hObject, handles);

function g_savemap_Callback(hObject, eventdata, handles)
load('.\pathsaved.mat');

temp=get(handles.g_mapdisplay,'value');
name=get(handles.g_mapdisplay,'string');
if ~isempty(name)
    Name=cell2mat(name(temp));
    Name=Name(5:end);
    Name=inputdlg('Please enter figure name:','',1,{Name});
    filename=[cell2mat(pathsaved(3)) '\' cell2mat(Name) '.png'];
    shapename=[cell2mat(pathsaved(3)) '\' cell2mat(Name) '.shp'];
    datax={};
    datay={};
    bname={};
    
    set(handles.text3,'visible','on');
    axes(handles.g_map);
    
    R=colormap;
    hfig=figure('visible','off');
    copyobj(handles.g_map,hfig);
    
    p=0;
    for i=1:length(name)
        s=cell2mat(name(i));
        if f_check(s,handles)
            if s(2)=='X'
                p=1;
                Filename=[cell2mat(pathsaved(3)) '\' s(4:end)];
                data=cell2mat(handles.mapgrid(i));
                data(find(data==-inf))=nan;
                geotiffwrite([Filename '_original.tif'],data,handles.mapref{1,i});
                data=cell2mat(handles.gridfocus(i));
                data(find(data==-inf))=nan;
                geotiffwrite([Filename '_focused.tif'],data,handles.mapref{1,i});
                
                data=cell2mat(handles.gridpeak(i));
                fid=fopen([Filename '_originalpeak.txt'],'wt');
                fprintf(fid, '%s\n', ['       Lat      Long     Value']);
                fprintf(fid,'%10.2f%10.2f%10.3f\n',data);
                fclose(fid);
                
                data=cell2mat(handles.gridpeak2(i));
                fid=fopen([Filename '_focusedpeak.txt'],'wt');
                fprintf(fid, '%s\n', ['       Lat      Long     Value']);
                fprintf(fid,'%10.2f%10.2f%10.3f\n',data);
                fclose(fid);
            end
        elseif ~isempty(strfind(s,'Event'))
            if s(2)=='X'
                E=size(handles.selectedevent);
                for j=1:E(1)
                    if handles.selectedevent{j,8}==i
                        tempx= handles.selectedevent{j,4};
                        tempy= handles.selectedevent{j,5};
                        tempb= handles.selectedevent{j,3};
                        tempx=tempx{1,1};
                        tempy=tempy{1,1};
                        tempb=tempb{1,1};
                        tempb=tempb';
                        L=size(tempx);
                        tempx=mat2cell(tempx,ones(L(1),1));
                        tempy=mat2cell(tempy,ones(L(1),1));
                    end
                end
                datax=[datax;tempx];
                datay=[datay;tempy];
                bname=[bname;tempb];
            end
        end
    end
    
    if ~isempty(datax)
        s=geoshape(datax,datay,'name',bname);
        t=makedbfspec(s);
        shapewrite(s,shapename,'DbfSpec',t);
    end
    
    if p==1
        colormap(R);
        co=colorbar;
        po=get(co,'position');
        po(4)=po(4)/2.5;
        set(co,'position',po);
    end
    
    print(filename,hfig,'-dpng');
    delete(hfig);
    set(handles.text3,'visible','off');
    msgbox('Figure saved.');
end

function g_savefig_Callback(hObject, eventdata, handles)
load('.\pathsaved.mat');

temp=get(handles.g_figuredis,'value');
name=get(handles.g_figuredis,'string');

if ~isempty(name)
    name=cell2mat(name(temp));
    hfig=figure('visible','off');
    copyobj(handles.figures(temp),hfig);
    if ~isempty(strfind(name,'Wind Rose'))
        title(name);
        name=name(1:end-7);
    elseif ~isempty(strfind(name,'CPF'))
        g=get(hfig,'children');
        g=get(g,'children');
        legend([g(2) g(1)],'CPF','Wind Frequence',...
            'Position',[350 30 0 0],'handlevisibility','on');
        title(name);
    elseif ~isempty(strfind(name,'Trend'))
        g=get(hfig,'children');
        g=get(g,'children');
        p=get(handles.legend(temp),'position');
        o=legend([g(1) g(2)],'Sen''s Slope','OLS Slope','handlevisibility','on');
        q=get(o,'position');
        set(o,'position',[p(1)+0.15 p(2)+0.05 0 0]);
    end
    
    filename=inputdlg('Please enter file name:','',1,{name});
    Filename=[cell2mat(pathsaved(3)) '\' cell2mat(filename) '.png'];
    print(Filename,hfig,'-dpng');
    Filename=[cell2mat(pathsaved(3)) '\' cell2mat(filename) '.txt'];
    fid=fopen(Filename,'wt');
    Data=cell2mat(handles.figuredata(temp));
    Data=Data';
    if ~isempty(strfind(name,'Time'))
        fprintf(fid, '%s\n', ['      Date      Conc']);
        fprintf(fid,'%10d%10.3f\n',Data);
    elseif ~isempty(strfind(name,'Monthly'))
        fprintf(fid, '%s\n', ['     Month      Conc']);
        fprintf(fid,'%10d%10.3f\n',Data);
    elseif ~isempty(strfind(name,'Weekly'))
        fprintf(fid, '%s\n', ['Day(Mon=1)      Conc']);
        fprintf(fid,'%10d%10.3f\n',Data);
    elseif ~isempty(strfind(name,'Hourly'))
        fprintf(fid, '%s\n', ['Hour(0~23)      Conc']);
        fprintf(fid,'%10d%10.3f\n',Data);
    elseif ~isempty(strfind(name,'Distribution'))
        fprintf(fid, '%s\n', ['   Centers    Counts']);
        fprintf(fid,'%10.3f%10d\n',Data);
    elseif ~isempty(strfind(name,'Wind'))
        fprintf(fid, '%s\n', [' Direction     Speed']);
        fprintf(fid,'%10d%10.3f\n',Data);
    elseif ~isempty(strfind(name,'CPF'))
        fprintf(fid, '%s\n', [' Direction       CPF      Wind']);
        fprintf(fid,'%10d%10.3f%10.3f\n',Data);
    elseif ~isempty(strfind(name,'Trend'))
        fprintf(fid, '%s\n', ['Sen''s slope (per year)']);
        fprintf(fid,'%10.3f\n',Data(1));
        fprintf(fid, '%s\n', ['OLS slope (per year)']);
        fprintf(fid,'%10.3f\n',Data(2));
    end
    fclose(fid);
    delete(hfig);
    msgbox('Figure saved.');
end
