function varargout = G_settraj(varargin)
% G_SETTRAJ MATLAB code for G_settraj.fig
%      G_SETTRAJ, by itself, creates a new G_SETTRAJ or raises the existing
%      singleton*.
%
%      H = G_SETTRAJ returns the handle to a new G_SETTRAJ or the handle to
%      the existing singleton*.
%
%      G_SETTRAJ('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in G_SETTRAJ.M with the given input arguments.
%
%      G_SETTRAJ('Property','Value',...) creates a new G_SETTRAJ or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before G_settraj_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to G_settraj_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help G_settraj

% Last Modified by GUIDE v2.5 16-Jun-2016 00:28:24

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @G_settraj_OpeningFcn, ...
                   'gui_OutputFcn',  @G_settraj_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before G_settraj is made visible.
function G_settraj_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to G_settraj (see VARARGIN)

% Choose default command line output for G_settraj
handles.output = hObject;
load (['.\sitelist.mat']);
% set species information
if ~isempty(sitelist)
    p=sitelist(:,1);
    set(handles.g_site,'string',p);
    p=cell2mat(p(1));
    load(['.\sitedata\' p '_date.mat']);
    Date=fix(Date(:,1)/10000);
    Date=unique(Date);
    set(handles.g_start,'string',Date);
    set(handles.g_start,'value',1);
    set(handles.g_end,'string',Date);
    set(handles.g_end,'value',length(Date));
else
    set(handles.g_site,'string',' ');
end

load('.\lasttraj.mat');
if ~isempty(lasttraj)
    set(handles.g_name,'string',cell2mat(lasttraj(1)));
    set(handles.g_pre,'string',cell2mat(lasttraj(2)));
    set(handles.g_suf,'string',cell2mat(lasttraj(3)));
    set(handles.g_date,'string',cell2mat(lasttraj(4)));
    set(handles.g_number,'string',cell2mat(lasttraj(5)));
end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes G_settraj wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = G_settraj_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function g_site_Callback(hObject, eventdata, handles)
p=get(handles.g_site,'string');
n=get(handles.g_site,'value');
p=cell2mat(p(n));
load(['.\sitedata\' p '_date.mat']);
Date=fix(Date(:,1)/10000);
Date=unique(Date);
set(handles.g_start,'string',Date);
set(handles.g_start,'value',1);
set(handles.g_end,'string',Date);
set(handles.g_end,'value',length(Date));
guidata(hObject, handles);


function g_check_Callback(hObject, eventdata, handles)
% check how many trajectory has been analysed at this trajectory parameter
% in order to reduce the repetitive work

sitename=get(handles.g_site,'string');
temp=get(handles.g_site,'value');
sitename=cell2mat(sitename(temp));

trajsite=sitename;
metero=get(handles.g_name,'string');
trajmetero=metero;
unit=get(handles.g_unit,'value');
height=str2num(get(handles.g_height,'string'));

if unit==1
    trajheight=[num2str(height) '-mixdepth'];
elseif unit==2
    trajheight=[num2str(height) '-ground' ];
else
    trajheight=[num2str(height) '-sealevel'];
end

filename=['.\trajdata\' trajsite '_' trajmetero '_' trajheight '.mat'];
if exist(filename)
    load(filename);
    temp=Lati(:,1);
    temp=fix(temp/10000);
    temp=unique(temp);
    k={};
    k(1)={['This trajectory (' trajsite '_' trajmetero '_' trajheight ') has been analysed:']};
    s=1;
    t=[];
    for i=1:length(temp)
        if mod(i,10)==0
        s=s+1;
        k(s)={t};
        t=[num2str(temp(i)) ';'];
        end
        t=[t num2str(temp(i)) ';'];
    end
    s=s+1;
    k(s)={t};
    msgbox(k);
else
    msgbox(['This trajectory (' trajsite '_' trajmetero '_' trajheight ') has never been analysed.']);
end


function g_confirm_Callback(hObject, eventdata, handles)
% get information
% sitename,site lati,longi
sitename=get(handles.g_site,'string');
temp=get(handles.g_site,'value');
sitename=cell2mat(sitename(temp));
load('.\sitelist.mat');
temp=size(sitelist);
for i=1:temp(1)
    if strcmp(sitename,cell2mat(sitelist(i,1)))
        lati=cell2mat(sitelist(i,2));
        longi=lati(2);
        lati=lati(1);
        break;
    end
end
% sitedate,Date(yyyymmddHH, yyyy, mm, dd, hh)
load(['.\sitedata\' sitename '_date.mat']);
temp=datevec(num2str(Date),'yyyymmddHH');
Date=[Date temp(:,1) temp(:,2) temp(:,3) temp(:,4)];
temp= get(handles.g_start,'value');
temp2=get(handles.g_end,'value');
if temp2<temp
    msgbox('Please check date selection.','Error','error');
    return;
end
index=get(handles.g_start,'string');
temp=str2num(index(temp,:));
temp2=str2num(index(temp2,:));
index1=find(Date(:,2)==fix(temp/100));
index2=find(Date(:,3)==mod(temp,100));
temp=intersect(index1,index2);
temp=temp(1);
index1=find(Date(:,2)==fix(temp2/100));
index2=find(Date(:,3)==mod(temp2,100));
temp2=intersect(index1,index2);
temp2=temp2(end);
Date=Date(temp:temp2,:);
% traj parameter
load('.\pathsaved.mat');
unit=get(handles.g_unit,'value');
height=str2num(get(handles.g_height,'string'));
if (unit==1 && height>1) || (isempty(height))
    msgbox('Please check height input.','Error','error');
    return;
end
time=str2num(get(handles.g_time,'string'));
op1=get(handles.g_op1,'value');
op2=get(handles.g_op2,'value');
head=str2num(get(handles.g_number,'string'))*3+4;
save('.\parameter','op1','op2','head','-append');

% generate date number, kk, 201201
dates=fix(Date(1,1)/1000000);
datee=fix(Date(end,1)/1000000);
kk=zeros((datee-dates+1)*12+2,1);
kk(1)=100*(dates-1)+12;
s=1;
for i=dates:datee
    for j=1:12
        s=s+1;
        kk(s)=i*100+j;
    end
end
kk(s+1)=(datee+1)*100+1;

%meterorodata formation
metero=get(handles.g_name,'string');
pre=get(handles.g_pre,'string');
suf=get(handles.g_suf,'string');
meterdate=get(handles.g_date,'string');
filenumber=str2num(get(handles.g_number,'string'));
if isempty(filenumber)
    msgbox('Please check your filenumber.','Error','error');
    return;
end
if filenumber>1
    Idex=find(suf=='#');
    if isempty(Idex)
        msgbox('Please check your filename.','Error','error');
        return;
    end
end

% generate bat

% meterodata folder
p=['echo ' cell2mat(pathsaved(1)) '\ >> CONTROL'];
% out put folder
q=['echo ' cell2mat(pathsaved(3)) '\ >> CONTROL'];
% heitgh
if unit==1
    kmsl=2;
elseif unit==2
    kmsl=0;
elseif unit==3
    kmsl=1;
end
% bat name
if cell2mat(pathsaved(5))==1
    name=[cell2mat(pathsaved(4)) '\working\G.bat']; 
else
    name=['.\working\G.bat']; 
end
fid=fopen(name,'wt'); % create file
h = waitbar(0,'Creating bat file...');
shownumber=100;
steps = size(Date);
steps=steps(1);
% record trajectory information, sitename, number, date, meterodata, height
trajsite=sitename; 
trajtime=time;
trajmetero=metero;
trajnumber=0;
trajdate=Date(:,1);
if unit==1
    trajheight=[num2str(height) '-mixdepth'];
elseif unit==2
    trajheight=[num2str(height) '-ground' ];
else
    trajheight=[num2str(height) '-sealevel'];
end

for i = 1:steps
    % computations take place here
    if mod(i,shownumber)==0
        waitbar(i/steps);
    end
    trajnumber=trajnumber+1;
    fprintf(fid,'%s\n','@echo off');
    % for accounting
    b=['echo ' num2str(trajnumber) ' > ' cell2mat(pathsaved(3)) '\count.txt'];
    fprintf(fid,'%s\n',b);
    
    b=['echo ' num2str(fix(Date(i,1)/1000000)) ' ' num2str(fix(mod(Date(i,1),1000000)/10000)) ' ' ...
        num2str(fix(mod(Date(i,1),10000)/100)) ' ' num2str(mod(Date(i,1),100)) ' > CONTROL'];
    fprintf(fid,'%s\n',b);
    fprintf(fid,'%s\n','echo 1 >> CONTROL ');% starting point number
    b=['echo ',num2str(lati),' ', num2str(longi),' ',num2str(height), ' >> CONTROL'];
    fprintf(fid,'%s\n',b);
    b=['echo ', num2str(time), ' >> CONTROL'];
    fprintf(fid,'%s\n',b);% trajectory time
    fprintf(fid,'%s\n','echo 0 >> CONTROL');
    fprintf(fid,'%s\n','echo 25000.0 >> CONTROL');
    b=['echo ', num2str(filenumber*3), ' >> CONTROL'];
    fprintf(fid,'%s\n',b);% meterorological file number
    
    Idex=[];
    Suf=suf;
    if filenumber>1
        Idex=find(Suf=='#');
    end
    
    for j=1:filenumber
        Suf(Idex)=num2str(j);
        
        N=fix(Date(i,1)/1000000)*100+fix(mod(Date(i,1),1000000)/10000);
        nn=datenum(num2str(N),'yyyymm');
        nn=datestr(nn,meterdate);
        nn1=['echo ' pre, nn, Suf,' >> CONTROL'];
        fprintf(fid,'%s\n',p);
        fprintf(fid,'%s\n',nn1);
        
        nn=kk(find(kk==N)-1);
        nn=datenum(num2str(nn),'yyyymm');
        nn=datestr(nn,meterdate);
        nn1=['echo ' pre, nn, Suf,' >> CONTROL'];
        fprintf(fid,'%s\n',p);
        fprintf(fid,'%s\n',nn1);
        
        nn=kk(find(kk==N)+1);
        nn=datenum(num2str(nn),'yyyymm');
        nn=datestr(nn,meterdate);
        nn1=['echo ' pre, nn, Suf,' >> CONTROL'];
        fprintf(fid,'%s\n',p);
        fprintf(fid,'%s\n',nn1);
    end
          
    fprintf(fid,'%s\n',q);
    b=['echo ', sitename, '_', num2str(Date(i,1)),'_', metero, '_', trajheight, '  >> CONTROL'];% output file name
    fprintf(fid,'%s\n',b);
    fprintf(fid,'%s\n','echo  ^&setup > SETUP.CFG');
    b=['echo kmsl =', num2str(kmsl), ', >> SETUP.CFG'];
    fprintf(fid,'%s\n',b);
    fprintf(fid,'%s\n','echo / >> SETUP.CFG');
    if cell2mat(pathsaved(5))==1
        fprintf(fid,'%s\n','..\exec\hyts_std');
    else
        fprintf(fid,'%s\n','hyts_std');
    end
end
fclose(fid);
close(h);
% save trajectory information
filename=['.\sitedata\' trajsite '_trajectory.mat'];
p=[trajsite '_' trajmetero '_' trajheight];
if exist(filename)
    load(filename);
    n=length(Trajectory);
    L=0;
    for i=1:n
        if strcmp(cell2mat(Trajectory(i)),p)
        L=1;
        end
    end
    if L==0
    Trajectory(n+1)={p};
    end
else
    Trajectory={p};
end
save(filename,'Trajectory');

save('.\parameter','trajnumber','trajsite','trajmetero','trajdate','trajheight', 'trajtime','-append');
% create vbs file
if cell2mat(pathsaved(5))==1
    name=[cell2mat(pathsaved(4)) '\working\G.vbs']; 
else
    name=['.\working\G.vbs']; 
end
fid=fopen(name,'wt'); % create file
fprintf(fid,'createobject ("wscript.shell").run "G.bat",0');
fclose(fid);

lasttraj(1)={get(handles.g_name,'string')};
lasttraj(2)={get(handles.g_pre,'string')};
lasttraj(3)={get(handles.g_suf,'string')};
lasttraj(4)={get(handles.g_date,'string')};
lasttraj(5)={get(handles.g_number,'string')};
save('.\lasttraj.mat','lasttraj');

close(handles.figure1);
