function varargout = G_trajimport(varargin)
% G_TRAJIMPORT MATLAB code for G_trajimport.fig
%      G_TRAJIMPORT, by itself, creates a new G_TRAJIMPORT or raises the existing
%      singleton*.
%
%      H = G_TRAJIMPORT returns the handle to a new G_TRAJIMPORT or the handle to
%      the existing singleton*.
%
%      G_TRAJIMPORT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in G_TRAJIMPORT.M with the given input arguments.
%
%      G_TRAJIMPORT('Property','Value',...) creates a new G_TRAJIMPORT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before G_trajimport_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to G_trajimport_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help G_trajimport

% Last Modified by GUIDE v2.5 22-Apr-2016 18:23:33

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @G_trajimport_OpeningFcn, ...
    'gui_OutputFcn',  @G_trajimport_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before G_trajimport is made visible.
function G_trajimport_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to G_trajimport (see VARARGIN)

% Choose default command line output for G_trajimport
handles.output = hObject;

load (['.\sitelist.mat']);
% set species information
if ~isempty(sitelist)
    p=sitelist(:,1);
    set(handles.g_site,'string',p);
    p=cell2mat(p(1));
    name=['.\sitedata\' p '_trajectory.mat'];
    if exist(name)
        load(['.\sitedata\' p '_trajectory.mat']);
        set(handles.g_item,'string',Trajectory);
        set(handles.g_item,'value',1);
    else
        set(handles.g_item,'string',{''});
        set(handles.g_item,'value',1);
    end
else
    set(handles.g_site,'string',' ');
end


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes G_trajimport wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = G_trajimport_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function g_time_Callback(hObject, eventdata, handles)


function g_time_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function g_site_Callback(hObject, eventdata, handles)
s=get(handles.g_site,'value');
p=get(handles.g_site,'string');
p=cell2mat(p(s));
load(['.\sitedata\' p '_trajectory.mat']);
set(handles.g_item,'string',Trajectory);
set(handles.g_item,'value',1);

function g_site_CreateFcn(hObject, eventdata, handles)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function g_item_Callback(hObject, eventdata, handles)


function g_item_CreateFcn(hObject, eventdata, handles)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function g_path_Callback(hObject, eventdata, handles)
[handles.file,handles.path] = uigetfile('*.*','Select trajectory output files','MultiSelect', 'on');
guidata(hObject, handles);

function g_add_Callback(hObject, eventdata, handles)
temp=inputdlg('Please input the new item name:','Input',1,{'Do not include site name'});
temp=cell2mat(temp);
s=get(handles.g_site,'string');
k=get(handles.g_site,'value');
s=cell2mat(s(k));
name=['.\sitedata\' s '_trajectory.mat'];
if exist(name)
    load(['.\sitedata\' s '_trajectory.mat']);
else
    Trajectory=cell(0);
end
n=length(Trajectory);
Trajectory(n+1)={[s '_' temp]};
set(handles.g_item,'string',Trajectory);
set(handles.g_item,'value',n+1);
save(['.\sitedata\' s '_trajectory.mat'],'Trajectory');
guidata(hObject, handles);

function g_import_Callback(hObject, eventdata, handles)
load ('.\pathsaved.mat');
if isempty(pathsaved)
    msgbox('Please setup path first.','Error','error');
    return;
end
% load information
load('.\pathsaved');

if ~isfield(handles,'path')
    msgbox('Please select trajectory files.','Error','error');
    return;
end
% initialize
time=str2num(get(handles.g_time,'string'));
number=length(handles.file);
lati=zeros(number,abs(time)+2); % date, endpoints (0~time)
lati(:,:)=nan;
longi=lati;
alti=lati;

hh = waitbar(0,'1','name','Importing Endpoints...');
steps=number;
shownumber=ceil(log10(steps));
for i=1:steps
    if mod(i,shownumber)==0
        waitbar(i / steps,hh,[num2str(i) '/' num2str(steps)]);
    end
    name=[handles.path cell2mat(handles.file(i))];
    if exist(name)
        a=textread(name,'%n',1);
        head=a+4;
        [a,b,c,d]=textread(name,'%n%n%n%n',1,'headerlines',a+2);
        textdata=textread(name,'','headerlines',head);
        lati(i,1)=a*1000000+b*10000+c*100+d;
        longi(i,1)=lati(i,1);
        alti(i,1)=lati(i,1);
        if ~isempty(textdata)
            textdata=textdata';
            t=size(textdata);
            temp=lati(i,:);
            temp(2:t(2)+1)=textdata(10,:);
            if length(lati(i,:))<length(temp)
                close(hh);
                msgbox('Please check the maximal trajectory time','Error','error');
                return;
            end
            lati(i,:)=temp;
            temp(2:t(2)+1)=textdata(11,:);
            longi(i,:)=temp;
            temp(2:t(2)+1)=textdata(12,:);
            alti(i,:)=temp;
        end
    end
end
close(hh);


% save data

temp=get(handles.g_item,'value');
filename=get(handles.g_item,'string');
filename=['.\trajdata\' cell2mat(filename(temp)) '.mat'];


if exist(filename)
    load(filename);% Lati, Longi
    n1=size(Lati);
    n2=size(lati);
    if n1(2)>n2(2)
        nn=zeros(n2(1),n1(2)-n2(2));
        nn(:,:)=nan;
        lati=[lati nn];
        longi=[longi nn];
        alti=[alti nn];
    elseif n2(2)>n1(2)
        nn=zeros(n1(1),n2(2)-n1(2));
        nn(:,:)=nan;
        Lati=[Lati nn];
        Longi=[Longi nn];
        Alti=[Alti nn];
    end
    Lati=[Lati;lati];
    [a,b]=unique(Lati(:,1),'last');
    Lati=Lati(b,:);
    Lati=sortrows(Lati,1);
    
    Longi=[Longi;longi];
    [a,b]=unique(Longi(:,1),'last');
    Longi=Longi(b,:);
    Longi=sortrows(Longi,1);
    
    Alti=[Alti;alti];
    [a,b]=unique(Alti(:,1),'last');
    Alti=Alti(b,:);
    Alti=sortrows(Alti,1);
else
    Lati=lati;
    Longi=longi;
    Alti=alti;
end
save(filename,'Lati','Longi','Alti');
